com.smartgwt.client.widgets.cube

## Class CubeGrid

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.widgets.grid.ListGrid
              - - com.smartgwt.client.widgets.cube.CubeGrid

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasFacetAddedHandlers, HasFacetMovedHandlers, HasFacetRemovedHandlers, HasFacetValueSelectionChangedHandlers, HasFixedFacetValueChangedHandlers, HasSortByFacetIdHandlers, HasSortByFacetValuesHandlers, DataBoundComponent, HasClickHandlers, HasDoubleClickHandlers, HasDragCompleteHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropCompleteHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFetchDataHandlers, HasFocusChangedHandlers, HasFormulaUpdatedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasBodyKeyPressHandlers, HasCellClickHandlers, HasCellContextClickHandlers, HasCellDoubleClickHandlers, HasCellErrorIconHoverHandlers, HasCellErrorIconOutHandlers, HasCellErrorIconOverHandlers, HasCellHoverHandlers, HasCellMouseDownHandlers, HasCellMouseUpHandlers, HasCellOutHandlers, HasCellOverHandlers, HasCellSavedHandlers, HasCellSelectionChangedHandlers, HasCellValueHoverHandlers, HasDataArrivedHandlers, HasDataChangedHandlers, HasDrawAreaChangedHandlers, HasEditCompleteHandlers, HasEditFailedHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFieldStateChangedHandlers, HasFilterEditorSubmitHandlers, HasGroupByCompleteHandlers, HasGroupByHandlers, HasGroupStateChangedHandlers, HasHeaderClickHandlers, HasHeaderDoubleClickHandlers, HasHeaderHoverHandlers, HasHilitesChangedHandlers, HasRecordClickHandlers, HasRecordCollapseHandlers, HasRecordDoubleClickHandlers, HasRecordDropHandlers, HasRecordExpandHandlers, HasRemoveRecordClickHandlers, HasRowContextClickHandlers, HasRowEditorEnterHandlers, HasRowEditorExitHandlers, HasRowHoverHandlers, HasRowMouseDownHandlers, HasRowMouseUpHandlers, HasRowOutHandlers, HasRowOverHandlers, HasSelectionChangedHandlers, HasSelectionUpdatedHandlers, HasSetSortHandlers, HasSortChangedHandlers, HasSorterClickHandlers, HasSorterContextClickHandlers, HasViewStateChangedHandlers, HasMembersChangedHandlers

      public class CubeGrid
      extends ListGrid
      implements HasFacetAddedHandlers, HasFacetMovedHandlers, HasFacetRemovedHandlers, HasFacetValueSelectionChangedHandlers, HasFixedFacetValueChangedHandlers, HasSortByFacetIdHandlers, HasSortByFacetValuesHandlers

  The CubeGrid is an interactive grid component that presents very large, multi-dimensional data sets (also known as data cubes) for reporting or analytic applications.

  CubeGrids are often called crosstabs, for their cross-tabular display of data dimensions in stacked/nested rows and columns, or pivot tables, for their ability to "pivot" dimensions between rows and columns to view a data cube from different perspectives. They are typically used in the querying and reporting front-ends of data warehousing, decision support, OLAP, and business intelligence systems.

  For example, CubeGrids can be connected to Pentaho Mondrian, Jasper Reports, Microsoft Analysis Services and any other OLAP technology that supports the XMLA standard - the Isomorphic public wiki has examples. of such integration.

  NOTE: you must load the Analytics `Optional Module` before you can use CubeGrid.

  Multi-Dimensional Data Terminology

  The CubeGrid refers to the dimensions of a data cube as facets, to the possible values in each facet as facet values, and to the values within the data cube as data values or cell values. Equivalent terms that are commonly used in data warehousing or business intelligence systems include:
  facet: dimension, attribute, feature
  facet value: dimension member, attribute value, feature value
  cell value: data value, metric value, measure

  Visual Structure

  Like the ListGrid and TreeGrid components, the CubeGrid displays data values in a tabular "body" with adjacent "headers". While the ListGrid and TreeGrid display rows of records with field values, the CubeGrid displays a body of individual cell values, each associated with a combination of facet values. The facet values for a cell are displayed in the column headers above the cell and row headers to the left of the cell. CubeGrids can display an arbitrary number of facets, by stacking multiple levels of row and/or column headers.

  Except for the innermost column facet, each facet in a CubeGrid has a facet label adjacent to its row or column headers. The facet labels serve two main purposes: they display the titles of the facets, and they provide drag-and-drop reordering or pivoting of facets within the CubeGrid. The row facet labels also provide interactive selection, resizing, and other operations on the columns of row facet values.

  The innermost column headers provide special behaviors and controls for manipulating the columns of data in a CubeGrid. End users may select, resize, reorder, minimize, maximize, or auto-fit the columns of data via mouse interactions with these headers. Customizable indicators and controls may be included at the top of each innermost column header.

  If a CubeGrid is not large enough to display all of its cell values, horizontal and/or vertical scrollbars will appear below and to the right of the body. The body of the CubeGrid may be scrolled on either axis. The headers are "frozen" from scrolling on one axis - row headers only scroll vertically, while column headers only scroll horizontally - so the facet values for the visible cells are always displayed.

  Data Loading

  Data can be provided to the Cube via `data` as an Array of `CellRecords`, each representing the data for one cell.

  For large datasets, `provide a DataSource` with one field per facetId, and the CubeGrid will load data on demand to fill the visible area, including lazily loading data for expanding/collapsing tree facets and when facetValues are made visible programmatically or via menus.

  Picking Facets

  By "facet" we mean an aspect of the data which is orthogonal to other aspects of the data, that is, combining values from any two "facets" should make sense.

  For example, in sales data, two facets might be "quarter" and "region" - it makes sense to combine any quarter and region, although for some combinations, there may not be data available.

  An example of two aspects that would not be independent facets are "state" and "city" - it's senseless to combine arbitrary states with arbitrary cities - most combinations are invalid. Consider instead a `tree facet` that combines "city" and "state" values.

  Note that if "city" and "state" are represented as facets, they may look correct if they are both on the same axis of the grid and `hideEmptyFacetValues` is used to trim nonsense combinations, but if the data is `pivoted` such that "state" and "city" are on opposing axes, there will be a roughly diagonal "stripe" of data for combinations of "state" and "city" that make sense, and all other space will be blank. This is a strong indication that two facets should be represented as a single tree facet instead.

  See Also:
    `Facet`, `FacetValue`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CubeGrid()`
    `CubeGrid(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addColumnFacet(java.lang.String facetId)` Add a column facet to the view at index "index".
    `void` | `addColumnFacet(java.lang.String facetId, java.lang.Integer index)` Add a column facet to the view at index "index".
    `void` | `addFacet(java.lang.String facetId)` Add a facet to the view, into the row or column facets (intoRows true or false), at index "index".
    `void` | `addFacet(java.lang.String facetId, java.lang.Boolean intoRows)`
    `void` | `addFacet(java.lang.String facetId, java.lang.Boolean intoRows, java.lang.Integer index)` Add a facet to the view, into the row or column facets (intoRows true or false), at index "index".
    `com.google.gwt.event.shared.HandlerRegistration` | `addFacetAddedHandler(FacetAddedHandler handler)` Add a facetAdded handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addFacetMovedHandler(FacetMovedHandler handler)` Add a facetMoved handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addFacetRemovedHandler(FacetRemovedHandler handler)` Add a facetRemoved handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addFacetValueSelectionChangedHandler(FacetValueSelectionChangedHandler handler)` Add a facetValueSelectionChanged handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addFixedFacetValueChangedHandler(FixedFacetValueChangedHandler handler)` Add a fixedFacetValueChanged handler.
    `void` | `addRowFacet(java.lang.String facetId)` Add a row facet to the view at index "index".
    `void` | `addRowFacet(java.lang.String facetId, java.lang.Integer index)` Add a row facet to the view at index "index".
    `com.google.gwt.event.shared.HandlerRegistration` | `addSortByFacetIdHandler(SortByFacetIdHandler handler)` Add a sortByFacetId handler.
    `com.google.gwt.event.shared.HandlerRegistration` | `addSortByFacetValuesHandler(SortByFacetValuesHandler handler)` Add a sortByFacetValues handler.
    `static boolean` | `analyticsLoaded()` Static method indicating whether the optional Analytics module is loaded for the page.
    `java.lang.Boolean` | `anyCellSelected()` Determine whether any cells are selected in this cubeGrid.
    `java.lang.Boolean` | `cellIsSelected(CellRecord cell)` Determine whether the cell passed in is selected in this cubeGrid.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `void` | `closeFacet(java.lang.String facetId)` Handler fired when facet is closed methodType handler
    `java.lang.Boolean` | `collapseField(FacetValueMap facetValueMap)` Collapses the specified field.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `void` | `dataArrived()` Notification method fired when new data arrives from the server to be displayed in this CubeGrid.
    `void` | `deselectAll()` Deselect all cells and facetValues.
    `void` | `deselectAllCells()` Deselect all cells.
    `void` | `deselectAllFacetValues()` Deselect all headers in a headerBar (specified by facetId) or all headerBars (if no facetId).
    `void` | `deselectAllFacetValues(java.lang.String facetId)` Deselect all headers in a headerBar (specified by facetId) or all headerBars (if no facetId).
    `void` | `deselectCell(CellRecord cell)` Deselect a single cell - accepts cellRecord.
    `void` | `deselectCell(java.lang.String cell)` Deselect a single cell - accepts cell ID.
    `void` | `deselectCells(CellRecord[] cellList)` Deselect cells that match a `FacetValueMap`.
    `void` | `deselectCells(FacetValueMap cellList)` Deselect cells that match a `FacetValueMap`.
    `void` | `deselectCells(java.lang.String... cellList)` Deselect cells that match a `FacetValueMap`.
    `void` | `deselectFacetValue(java.lang.String facetId, java.lang.String facetValueId)` Deselect the header for a given facet value.
    `java.lang.Boolean` | `expandField(FacetValueMap facetValueMap)` Expands the specified field.
    `void` | `exportClientData(java.util.Map settings)` Exports this component's data with client-side formatters applied, so is suitable for direct display to users.
    `void` | `exportClientData(java.util.Map settings, DSRequest requestProperties)`
    `void` | `exportClientData(java.util.Map settings, DSRequest requestProperties, RPCCallback callback)` Exports this component's data with client-side formatters applied, so is suitable for direct display to users.
    `java.lang.Boolean` | `facetHasSelection(java.lang.String facetId)` Return whether any facet value for this facet is selected in headers.
    `java.lang.Boolean` | `getAlternateRecordStyles()` Whether alternating rows should be drawn in alternating styles, in order to create a "ledger" effect for easier reading.
    `TextMatchStyle` | `getAutoFetchTextMatchStyle()` If `autoFetchData` is `true`, this attribute allows the developer to specify a textMatchStyle for the initial `fetchData()` call.
    `java.lang.Boolean` | `getAutoSelectHeaders()` If true, when multiple facets appear on one side in a nested headers presentation, the selection state of parent/child headers are automatically kept in sync.
    `AutoSelectionModel` | `getAutoSelectValues()` Whether to select cells in the body when row or column headers are selected.
    `java.lang.Boolean` | `getAutoSizeHeaders()` Automatically size row headers to fit wrapped text.
    `java.lang.String` | `getBaseStyle()` `base cell style` for this listGrid.
    `java.lang.Integer` | `getBodyMinHeight()` Minimum height for the body of this cubeGrid.
    `java.lang.Integer` | `getBodyMinWidth()` Minimum width for the body of this cubeGrid.
    `java.lang.String` | `getBodyStyleName()` CSS class for the CubeGrid body
    `java.lang.Boolean` | `getCanCollapseFacets()` If true, hierarchical facets will show expand/collapse controls to allow the user to expand and collapse the tree of facetValues for that facet.
    `java.lang.Boolean` | `getCanDragSelect()` For `touch browsers`, `canDragSelect` defaults to false so that touch scrolling can be used to navigate scrollable CubeGrids.
    `java.lang.Boolean` | `getCanEdit()` Whether cells can be edited in this grid.
    `java.lang.Boolean` | `getCanMinimizeColumns()` If true, allow columns in the grid body to be minimized (reduced to the width of the minimize control) by clicking on a minimize control in the innermost column headers.
    `java.lang.Boolean` | `getCanMinimizeFacets()` If true, when multiple facets are shown on a side, all facetValues in the second level of headers or higher will show controls to "minimize" the values of the next facet.
    `java.lang.Boolean` | `getCanMoveFacets()` Whether row and column facets can be rearranged by the user, by dragging and dropping the facet labels.
    `java.lang.Boolean` | `getCanReorderColumns()` If true, body columns can be reordered via the innermost column headers.
    `java.lang.Boolean` | `getCanResizeColumns()` If true, body columns can be resized via the innermost column headers.
    `java.lang.Boolean` | `getCanSelectHeaders()` Determines whether row or column facetValue headers can be selected.
    `java.lang.Boolean` | `getCanSelectValues()` Determines whether cell values in the body can be selected.
    `java.lang.Boolean` | `getCanSortData()` If true, sort controls will be shown on facet values.
    `java.lang.Boolean` | `getCanSortFacets()` If true, sort controls will be shown on FacetHeaders.
    `Alignment` | `getCellAlign()` Default align for cell values (in body).
    `int` | `getCellColumn(CellRecord cellRecord)` Given a record in this grid, this method returns the colNum in which the record is displayed.
    `int[]` | `getCellCoordinates(CellRecord cellRecord)` Given a record in this grid, this method returns the coordinates of the cell in which the record is displayed as a 2 element array.
    `FacetValueMap` | `getCellFacetValues(int rowNum, int colNum)` Given a cell coordinate within this CubeGrid return a `FacetValueMap` indicating the facet values for the cell.
    `java.lang.String` | `getCellIdProperty()` Name of the property in a cell record that holds it's unique ID.
    `ListGridRecord` | `getCellRecord(int rowNum, int colNum)` Return the pointer to a particular record by record and column number.
    `int` | `getCellRow(CellRecord cellRecord)` Given a record in this grid, this method returns the rowNum on which the record is displayed.
    `int` | `getChartConfirmThreshold()` If `makeChart()` is called with a chart specification that will show more than `chartConfirmThreshold` data elements, the user will be presented with a `confirmation dialog`.
    `java.lang.String` | `getChartConstructor()` Name of the Smart GWT Class to be used when creating charts.
    `ChartType` | `getChartType()` Default type of chart to plot.
    `java.lang.String` | `getColHeaderBaseStyle()` `baseStyle` for the buttons in this grid's column headers.
    `java.lang.String[]` | `getColumnFacets()` The list of `ids` for facets that will appear on top of the body.
    `FacetValueMap` | `getColumnFacetValues(int colNum)` Return a `FacetValueMap` indicating the facet values for a specific column in the grid.
    `int` | `getDefaultFacetWidth()` Default width of inner column headers.
    `java.lang.Boolean` | `getEditByCell()` CubeGrids only support editing by cell.
    `java.lang.Object` | `getEditedCell(int rowNum, int colNum)` Returns the current value of a cell.
    `java.lang.Object` | `getEditedCell(Record record)` Returns the current value of a cell.
    `CellRecord` | `getEditedRecord(int rowNum, int colNum)` Returns the combination of unsaved edits (if any) and original values (if any) for a given cell being edited.
    `CellRecord` | `getEditedRecord(Record baseRecord)` Returns the combination of unsaved edits (if any) and original values (if any) for a given cell being edited.
    `java.lang.Object` | `getEditValue(int rowNum, int colNum)` Returns the current temporary locally stored edit value for a cell being edited.
    `java.lang.Boolean` | `getEnableCharting()` If set to true, context menu items will be included on the cells and headers providing the user with an option to create a chart of the cubeGrid's data set.
    `int` | `getEventColumn()` Returns the column number of the most recent mouse event.
    `int` | `getEventColumn(java.lang.Integer x)` Returns the column number of the most recent mouse event.
    `int` | `getEventRow()` Returns the row number of the most recent mouse event.
    `int` | `getEventRow(java.lang.Integer y)` Returns the row number of the most recent mouse event.
    `java.lang.String` | `getExportColumnFacetBGColor()` Sets the background color for the column headers of the cube.
    `java.lang.String` | `getExportColumnFacetTextColor()` Sets the text color for the column headers of the cube.
    `java.lang.String` | `getExportFacetBGColor()` Sets the background color for the row and column headers of the cube, if not otherwise set by a more specific property.
    `java.lang.String` | `getExportFacetSeparatorString()` Default separator string used by `exportClientData()` to separate column and row facet value titles.
    `java.lang.String` | `getExportFacetTextColor()` Sets the text color for the row and column headers of the cube, if not otherwise set by a more specific property.
    `java.lang.String` | `getExportRowFacetBGColor()` Sets the background color for the row headers of the cube.
    `java.lang.String` | `getExportRowFacetTextColor()` Sets the text color for the row headers of the cube.
    `Facet` | `getFacet(java.lang.String facetId)` Get a facet definition by facetId.
    `Alignment` | `getFacetLabelHoverAlign()` Allows the developer to override the horizontal text alignment of hover tips shown for facetLabels.
    `java.lang.Integer` | `getFacetLabelHoverHeight()` If specified and `this.showHover` is true, this is the default height to apply to hover tips shown for facetLabels.
    `java.lang.String` | `getFacetLabelHoverStyle()` Allows the developer to override the css class applied to hover tips shown for facet labels.
    `VerticalAlignment` | `getFacetLabelHoverVAlign()` Allows the developer to override the vertical text alignment of hover tips shown for facetLabels.
    `java.lang.Integer` | `getFacetLabelHoverWidth()` If specified and `this.showHover` is true, this is the default width to apply to hover tips shown for facetLabels.
    `java.lang.String[]` | `getFacetsHavingSelection()` Return the list of facets that have any selection in their headers.
    `Alignment` | `getFacetTitleAlign()` Default alignment for facet labels.
    `FacetValue` | `getFacetValue(java.lang.String facetId, java.lang.String facetValueId)` Get a facet value definition by facetId and facetValueId.
    `Alignment` | `getFacetValueAlign()` Default alignment for facet values (in headers).
    `Alignment` | `getFacetValueHoverAlign()` Allows the developer to override the horizontal text alignment of hover tips shown for facet values.
    `java.lang.Integer` | `getFacetValueHoverHeight()` If specified and `this.showHover` is true, this is the default height to apply to hover tips shown for facetValues.
    `java.lang.String` | `getFacetValueHoverStyle()` Allows the developer to override the css class applied to hover tips shown for facet values.
    `VerticalAlignment` | `getFacetValueHoverVAlign()` Allows the developer to override the vertical text alignment of hover tips shown for facet values.
    `java.lang.Integer` | `getFacetValueHoverWidth()` If specified and `this.showHover` is true, this is the default width to apply to hover tips shown for facetValues.
    `int` | `getFacetValuesColumn(FacetValueMap facetValues)` Get the index of the first column in the grid that matches the specified FacetValueMap.
    `int` | `getFacetValuesRow(FacetValueMap facetValues)` Get the index of the first row in the grid that matches the specified FacetValueMap.
    `FacetValueMap` | `getFixedFacetValues()` A `FacetValueMap` describing the set of facet values that should be regarded as "fixed" in this cubeGrid.
    `Axis` | `getHideEmptyAxis()` With `hideEmptyFacetValues`, controls on which axis hiding of empty values is applied, "row" (only empty rows are hidden), "column" (only empty columns are hidden) or both (the default).
    `java.lang.Boolean` | `getHideEmptyFacetValues()` This causes the headers for any combination of facetValues for which there are no cellRecords to be suppressed.
    `Hilite[]` | `getHilites()` Hilites to be applied to the data for this component.
    `java.lang.String` | `getInnerHeaderBaseStyle()` `baseStyle` for the buttons in the innermost column header for this cubeGrid.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `java.lang.String` | `getMetricFacetId()` In a CubeGrid that displays values of different types (eg "Revenue" and "Income"), the different types of values on display are enumerated as the facet values of the "metric facet".
    `static CubeGrid` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.Boolean` | `getPadTitles()` Whether to pad titles so they aren't flush with header borders.
    `java.lang.String` | `getRollupValue()` facetValueId of the default rollupValue for each facet.
    `java.lang.String[]` | `getRowFacets()` The list of `ids` for facets that will appear to the left of the body.
    `FacetValueMap` | `getRowFacetValues(int rowNum)` Return a `FacetValueMap` indicating the facet values for a specific row in the grid.
    `java.lang.String` | `getRowHeaderBaseStyle()` `baseStyle` for the buttons in this grid's row headers.
    `java.lang.Boolean` | `getRowHeaderGridMode()` If enabled row headers for this cubeGrid will be rendered using a `GridRenderer` component.
    `java.lang.Boolean` | `getSaveByCell()` CubeGrids only support editing by cell.
    `java.lang.String[]` | `getSelectedCellIds()` Returns an array of the IDs of all selected cell records.
    `CellRecord[]` | `getSelectedCells()` Returns an array of the selected cell records.
    `FacetValueMap[]` | `getSelectedFacetValues(java.lang.String facetId)` Returns an array of facetValues objects indicating the headers that are selected in the headerBar for this facet.
    `boolean` | `getShowFacetValueContextMenus()` If true, show facet value context menus with some built-in operations.
    `java.lang.Boolean` | `getSimpleDeselect()` If true, clicking on the existing selection causes it to be entirely deselected.
    `java.lang.String` | `getSkinImgDir()` Default directory for skin images (those defined by the class), relative to the Page-wide `skinDir`.
    `SortDirection` | `getSortDirection()` Direction of sorting if sortedFacet or sortedFacetValues is specified.
    `FacetValueMap` | `getSortedFacetValues()` `FacetValueMap` of facet values representing a set of facetValues by which the cubeGrid data is sorted.
    `java.lang.String` | `getStyleName()` CSS class for the CubeGrid as a whole
    `java.lang.String` | `getValueExportFormat()` `FormatString` used during exports for numeric or date formatting.
    `java.lang.String` | `getValueFormat()` `FormatString` for numeric or date formatting.
    `java.lang.String` | `getValueProperty()` Name of the property in a cell record that holds the cell value.
    `java.lang.String` | `getValueTitle()` A label for the data values shown in cells, such as "Sales in Thousands", typically used when the CubeGrid must generate a description for a cell value or set of cell values.
    `java.lang.Boolean` | `getWrapFacetTitles()` Whether to allow text wrapping on facet titles.
    `java.lang.Boolean` | `getWrapFacetValueTitles()` Whether to allow text wrapping on facet value titles.
    `java.lang.Boolean` | `hasChanges()` Determines whether any cells in this cubeGrid have been edited but not yet saved to the underlying data set.
    `java.lang.Boolean` | `hiliteCell(int rowNum, int colNum, java.lang.String hiliteID)` Apply a hilite to a specific cell.
    `java.lang.Boolean` | `hiliteFacetValue(java.lang.String facetID, java.lang.String facetValueID, java.lang.String hiliteID)` Apply a hilite to all cells corresponding to a facetValue.
    `FacetChart` | `makeChart(FacetValueMap fixedFacetValues, java.lang.String[] variableFacets, FacetChart chartProperties)` Chart the portion of the dataset indicated by `fixedFacetValues`, for all values of the `variableFacets`.
    `java.lang.Boolean` | `recordHasChanges(int rowNum, int colNum)` If this cubeGrid can be edited, this method will return true if the record passed in has been edited, but the edits have not yet been saved to the CubeGrid's data object.
    `void` | `removeFacet(java.lang.String facetId)` Remove a facet from the current view, using a fixed value from that facet.
    `void` | `removeFacet(java.lang.String facetId, java.lang.String fixedFacetValueId)` Remove a facet from the current view, using a fixed value from that facet.
    `void` | `resizeFacetValue(java.lang.String facetValueId, int newWidth)` Resizes all columns for the provided facetValueId, which must be a facetValueId from the innermost column facet.
    `void` | `selectAllCells()` Select all cells.
    `void` | `selectAllFacetValues()` Select/deselect all headers in a headerBar (specified by facetId) or all headerBars (if no facetId).
    `void` | `selectAllFacetValues(java.lang.String facetId)`
    `void` | `selectAllFacetValues(java.lang.String facetId, java.lang.Boolean newState)` Select/deselect all headers in a headerBar (specified by facetId) or all headerBars (if no facetId).
    `void` | `selectCell(Record cell)` Select a single cell - accepts cell ID or cell record.
    `void` | `selectCell(java.lang.String ID)` Select a single cell - accepts cell ID or cell record.
    `void` | `selectCells(CellRecord[] cellList)` Select/deselect cells that match a `FacetValueMap`.
    `void` | `selectCells(CellRecord[] cellList, boolean newState)` Select/deselect cells that match a `FacetValueMap`.
    `void` | `selectCells(FacetValueMap cellList)` Select/deselect cells that match a `FacetValueMap`.
    `void` | `selectCells(java.lang.String... cellList)` Select/deselect cells that match a `FacetValueMap`.
    `void` | `selectFacetValue(java.lang.String facetId, java.lang.String facetValueId)` Select/deselect the header for a given facet value.
    `void` | `selectFacetValue(java.lang.String facetId, java.lang.String facetValueId, java.lang.Boolean newState)` Select/deselect the header for a given facet value.
    `void` | `setAlternateRecordStyles(java.lang.Boolean alternateRecordStyles)` Whether alternating rows should be drawn in alternating styles, in order to create a "ledger" effect for easier reading.
    `void` | `setAutoFetchTextMatchStyle(TextMatchStyle autoFetchTextMatchStyle)` If `autoFetchData` is `true`, this attribute allows the developer to specify a textMatchStyle for the initial `fetchData()` call.
    `void` | `setAutoSelectHeaders(java.lang.Boolean autoSelectHeaders)` If true, when multiple facets appear on one side in a nested headers presentation, the selection state of parent/child headers are automatically kept in sync.
    `void` | `setAutoSelectValues(AutoSelectionModel autoSelectValues)` Whether to select cells in the body when row or column headers are selected.
    `void` | `setAutoSizeHeaders(java.lang.Boolean autoSizeHeaders)` Automatically size row headers to fit wrapped text.
    `void` | `setBaseStyle(java.lang.String baseStyle)` `base cell style` for this listGrid.
    `void` | `setBodyMinHeight(java.lang.Integer bodyMinHeight)` Minimum height for the body of this cubeGrid.
    `void` | `setBodyMinWidth(java.lang.Integer bodyMinWidth)` Minimum width for the body of this cubeGrid.
    `void` | `setBodyStyleName(java.lang.String bodyStyleName)` CSS class for the CubeGrid body
    `void` | `setCanCollapseFacets(java.lang.Boolean canCollapseFacets)` If true, hierarchical facets will show expand/collapse controls to allow the user to expand and collapse the tree of facetValues for that facet.
    `void` | `setCanDragSelect(java.lang.Boolean canDragSelect)` For `touch browsers`, `canDragSelect` defaults to false so that touch scrolling can be used to navigate scrollable CubeGrids.
    `void` | `setCanEdit(java.lang.Boolean canEdit)` Whether cells can be edited in this grid.
    `void` | `setCanMinimizeColumns(java.lang.Boolean canMinimizeColumns)` If true, allow columns in the grid body to be minimized (reduced to the width of the minimize control) by clicking on a minimize control in the innermost column headers.
    `void` | `setCanMinimizeFacets(java.lang.Boolean canMinimizeFacets)` If true, when multiple facets are shown on a side, all facetValues in the second level of headers or higher will show controls to "minimize" the values of the next facet.
    `void` | `setCanMoveFacets(java.lang.Boolean canMoveFacets)` Whether row and column facets can be rearranged by the user, by dragging and dropping the facet labels.
    `void` | `setCanReorderColumns(java.lang.Boolean canReorderColumns)` If true, body columns can be reordered via the innermost column headers.
    `void` | `setCanResizeColumns(java.lang.Boolean canResizeColumns)` If true, body columns can be resized via the innermost column headers.
    `void` | `setCanSelectHeaders(java.lang.Boolean canSelectHeaders)` Determines whether row or column facetValue headers can be selected.
    `void` | `setCanSelectValues(java.lang.Boolean canSelectValues)` Determines whether cell values in the body can be selected.
    `void` | `setCanSortData(java.lang.Boolean canSortData)` If true, sort controls will be shown on facet values.
    `void` | `setCanSortFacets(java.lang.Boolean canSortFacets)` If true, sort controls will be shown on FacetHeaders.
    `void` | `setCellAlign(Alignment cellAlign)` Default align for cell values (in body).
    `void` | `setCellIdProperty(java.lang.String cellIdProperty)` Name of the property in a cell record that holds it's unique ID.
    `void` | `setChartConfirmThreshold(int chartConfirmThreshold)` If `makeChart()` is called with a chart specification that will show more than `chartConfirmThreshold` data elements, the user will be presented with a `confirmation dialog`.
    `void` | `setChartConstructor(java.lang.String chartConstructor)` Name of the Smart GWT Class to be used when creating charts.
    `void` | `setChartType(ChartType chartType)` Default type of chart to plot.
    `void` | `setColHeaderBaseStyle(java.lang.String colHeaderBaseStyle)` `baseStyle` for the buttons in this grid's column headers.
    `void` | `setColumnFacets(java.lang.String... columnFacets)` The list of `ids` for facets that will appear on top of the body.
    `void` | `setDefaultFacetWidth(int defaultFacetWidth)` Default width of inner column headers.
    `static void` | `setDefaultProperties(CubeGrid cubeGridProperties)` Class level method to set the default properties of this class.
    `void` | `setEditValue(int rowNum, int colNum, java.lang.Object value)` Set the edit value for some cell in the cube grid.
    `void` | `setEnableCharting(java.lang.Boolean enableCharting)` If set to true, context menu items will be included on the cells and headers providing the user with an option to create a chart of the cubeGrid's data set.
    `void` | `setExportColumnFacetBGColor(java.lang.String exportColumnFacetBGColor)` Sets the background color for the column headers of the cube.
    `void` | `setExportColumnFacetTextColor(java.lang.String exportColumnFacetTextColor)` Sets the text color for the column headers of the cube.
    `void` | `setExportFacetBGColor(java.lang.String exportFacetBGColor)` Sets the background color for the row and column headers of the cube, if not otherwise set by a more specific property.
    `void` | `setExportFacetSeparatorString(java.lang.String exportFacetSeparatorString)` Default separator string used by `exportClientData()` to separate column and row facet value titles.
    `void` | `setExportFacetTextColor(java.lang.String exportFacetTextColor)` Sets the text color for the row and column headers of the cube, if not otherwise set by a more specific property.
    `void` | `setExportRowFacetBGColor(java.lang.String exportRowFacetBGColor)` Sets the background color for the row headers of the cube.
    `void` | `setExportRowFacetTextColor(java.lang.String exportRowFacetTextColor)` Sets the text color for the row headers of the cube.
    `void` | `setFacetLabelHoverAlign(Alignment facetLabelHoverAlign)` Allows the developer to override the horizontal text alignment of hover tips shown for facetLabels.
    `void` | `setFacetLabelHoverHeight(java.lang.Integer facetLabelHoverHeight)` If specified and `this.showHover` is true, this is the default height to apply to hover tips shown for facetLabels.
    `void` | `setFacetLabelHoverStyle(java.lang.String facetLabelHoverStyle)` Allows the developer to override the css class applied to hover tips shown for facet labels.
    `void` | `setFacetLabelHoverVAlign(VerticalAlignment facetLabelHoverVAlign)` Allows the developer to override the vertical text alignment of hover tips shown for facetLabels.
    `void` | `setFacetLabelHoverWidth(java.lang.Integer facetLabelHoverWidth)` If specified and `this.showHover` is true, this is the default width to apply to hover tips shown for facetLabels.
    `void` | `setFacets(Facet... facets)` Facet definitions for this CubeGrid.
    `void` | `setFacetTitle(java.lang.String facetId, java.lang.String newTitle)` Set the title of a facet (appears in facet label).
    `void` | `setFacetTitleAlign(Alignment facetTitleAlign)` Default alignment for facet labels.
    `void` | `setFacetValueAlign(Alignment facetValueAlign)` Default alignment for facet values (in headers).
    `void` | `setFacetValueHoverAlign(Alignment facetValueHoverAlign)` Allows the developer to override the horizontal text alignment of hover tips shown for facet values.
    `void` | `setFacetValueHoverHeight(java.lang.Integer facetValueHoverHeight)` If specified and `this.showHover` is true, this is the default height to apply to hover tips shown for facetValues.
    `void` | `setFacetValueHoverStyle(java.lang.String facetValueHoverStyle)` Allows the developer to override the css class applied to hover tips shown for facet values.
    `void` | `setFacetValueHoverVAlign(VerticalAlignment facetValueHoverVAlign)` Allows the developer to override the vertical text alignment of hover tips shown for facet values.
    `void` | `setFacetValueHoverWidth(java.lang.Integer facetValueHoverWidth)` If specified and `this.showHover` is true, this is the default width to apply to hover tips shown for facetValues.
    `void` | `setFacetValueTitle(java.lang.String facetId, java.lang.String facetValueId, java.lang.String newTitle)` Set the title for a facet value.
    `void` | `setFacetValueTitleAlign(java.lang.String facetId, java.lang.String facetValueId, Alignment align)` Set the align for the title for a facet value.
    `void` | `setFixedFacetValue(java.lang.String facetId, java.lang.String fixedFacetValueId)` Modify fixedFacetValues for this cubeGrid.
    `void` | `setFixedFacetValues(FacetValueMap fixedFacetValues)` A `FacetValueMap` describing the set of facet values that should be regarded as "fixed" in this cubeGrid.
    `void` | `setHideEmptyAxis(Axis hideEmptyAxis)` With `hideEmptyFacetValues`, controls on which axis hiding of empty values is applied, "row" (only empty rows are hidden), "column" (only empty columns are hidden) or both (the default).
    `void` | `setHideEmptyFacetValues(java.lang.Boolean hideEmptyFacetValues)` This causes the headers for any combination of facetValues for which there are no cellRecords to be suppressed.
    `void` | `setHilites(Hilite... hilites)` Hilites to be applied to the data for this component.
    `void` | `setInnerHeaderBaseStyle(java.lang.String innerHeaderBaseStyle)` `baseStyle` for the buttons in the innermost column header for this cubeGrid.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.cube.CubeGridLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `void` | `setMetricFacetId(java.lang.String metricFacetId)` In a CubeGrid that displays values of different types (eg "Revenue" and "Income"), the different types of values on display are enumerated as the facet values of the "metric facet".
    `void` | `setPadTitles(java.lang.Boolean padTitles)` Whether to pad titles so they aren't flush with header borders.
    `void` | `setRollupValue(java.lang.String rollupValue)` facetValueId of the default rollupValue for each facet.
    `void` | `setRowFacets(java.lang.String... rowFacets)` The list of `ids` for facets that will appear to the left of the body.
    `void` | `setRowHeaderBaseStyle(java.lang.String rowHeaderBaseStyle)` `baseStyle` for the buttons in this grid's row headers.
    `void` | `setRowHeaderGridMode(java.lang.Boolean rowHeaderGridMode)` If enabled row headers for this cubeGrid will be rendered using a `GridRenderer` component.
    `void` | `setShowFacetValueContextMenus(boolean showFacetValueContextMenus)` If true, show facet value context menus with some built-in operations.
    `void` | `setSimpleDeselect(java.lang.Boolean simpleDeselect)` If true, clicking on the existing selection causes it to be entirely deselected.
    `void` | `setSkinImgDir(java.lang.String skinImgDir)` Default directory for skin images (those defined by the class), relative to the Page-wide `skinDir`.
    `void` | `setSortDirection(SortDirection sortDirection)` Direction of sorting if sortedFacet or sortedFacetValues is specified.
    `void` | `setSortedFacetValues(FacetValueMap sortedFacetValues)` `FacetValueMap` of facet values representing a set of facetValues by which the cubeGrid data is sorted.
    `void` | `setStyleName(java.lang.String styleName)` CSS class for the CubeGrid as a whole
    `void` | `setValueExportFormat(java.lang.String valueExportFormat)` `FormatString` used during exports for numeric or date formatting.
    `void` | `setValueFormat(java.lang.String valueFormat)` `FormatString` for numeric or date formatting.
    `void` | `setValueProperty(java.lang.String valueProperty)` Name of the property in a cell record that holds the cell value.
    `void` | `setValueTitle(java.lang.String valueTitle)` A label for the data values shown in cells, such as "Sales in Thousands", typically used when the CubeGrid must generate a description for a cell value or set of cell values.
    `void` | `setWrapFacetTitles(java.lang.Boolean wrapFacetTitles)` Whether to allow text wrapping on facet titles.
    `void` | `setWrapFacetValueTitles(java.lang.Boolean wrapFacetValueTitles)` Whether to allow text wrapping on facet value titles.
    `java.lang.Boolean` | `toggleFieldOpenState(FacetValueMap facetValueMap)` Toggles the open state of the specified field.

    - ### Methods inherited from class com.smartgwt.client.widgets.grid.ListGrid

      `addBodyKeyPressHandler, addCellClickHandler, addCellContextClickHandler, addCellDoubleClickHandler, addCellErrorIconHoverHandler, addCellErrorIconOutHandler, addCellErrorIconOverHandler, addCellHoverHandler, addCellMouseDownHandler, addCellMouseUpHandler, addCellOutHandler, addCellOverHandler, addCellSavedHandler, addCellSelectionChangedHandler, addCellValueHoverHandler, addData, addData, addData, addDataArrivedHandler, addDataChangedHandler, addDragCompleteHandler, addDrawAreaChangedHandler, addDropCompleteHandler, addEditCompleteHandler, addEditFailedHandler, addEditorEnterHandler, addEditorExitHandler, addEmbeddedComponent, addEmbeddedComponent, addEmbeddedComponent, addEmbeddedComponent, addFetchDataHandler, addFieldStateChangedHandler, addFilterEditorSubmitHandler, addFormulaField, addFormulaUpdatedHandler, addGroupByCompleteHandler, addGroupByHandler, addGroupStateChangedHandler, addHeaderClickHandler, addHeaderDoubleClickHandler, addHeaderHoverHandler, addHilitesChangedHandler, addRecordClickHandler, addRecordCollapseHandler, addRecordDoubleClickHandler, addRecordDropHandler, addRecordExpandHandler, addRemoveRecordClickHandler, addRowContextClickHandler, addRowEditorEnterHandler, addRowEditorExitHandler, addRowHoverHandler, addRowMouseDownHandler, addRowMouseUpHandler, addRowOutHandler, addRowOverHandler, addSelectionChangedHandler, addSelectionUpdatedHandler, addSetSortHandler, addSort, addSortChangedHandler, addSorterClickHandler, addSorterContextClickHandler, addSummaryField, addViewStateChangedHandler, anySelected, applyCellData, applyRecordData, applySortToData, autoFitField, autoFitFields, autoFitFields, cancelEditing, canEditCell, canExpandRecord, canSelectCell, canSelectRecord, cellHasChanges, cellHasErrors, cellHasErrors, cellValueHoverHTML, cellValueIsClipped, chartData, chartData, chartData, chartData, chartData, clearCriteria, clearCriteria, clearCriteria, clearEditValue, clearFieldError, clearFieldError, clearRowErrors, clearSort, closeGroup, closeRecord, collapseRecord, collapseRecords, configureGrouping, createRecordComponent, deselectAllRecords, deselectRange, deselectRecord, deselectRecord, deselectRecords, deselectRecords, disableHilite, disableHiliting, discardAllEdits, discardAllEdits, discardAllEdits, discardEdits, discardEdits, displayHeaderContextMenu, displaySort, editFields, editHilites, enableHilite, enableHilite, enableHiliting, enableHiliting, endEditing, expandRecord, expandRecords, exportClientData, exportClientData, exportClientData, exportData, exportData, fetchData, fetchData, fetchData, fetchData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fetchRelatedData, fieldIsEditable, fieldIsEditable, fieldIsEditable, fieldIsVisible, filterByEditor, filterData, filterData, filterData, filterData, find, findAll, findIndex, findNextEditCell, findNextIndex, findNextIndex, focusInCell, focusInFilterEditor, focusInFilterEditor, focusInRow, freezeField, freezeField, freezeField, freezeField, freezeFields, freezeFields, getAddDropValues, getAddFormulaFieldText, getAddOperation, getAddSummaryFieldText, getAdvancedFieldPickerThreshold, getAllEditRows, getAllFields, getAllowFilterExpressions, getAllowRowSpanning, getAlternateBodyStyleName, getAlternateFieldFrequency, getAlternateFieldStyles, getAlternateRecordFrequency, getAlwaysShowEditors, getAnimateFolderEffect, getAnimateFolderMaxRows, getAnimateFolders, getAnimateFolderSpeed, getAnimateFolderTime, getAnimateRemoveRecord, getAnimateRemoveSpeed, getAnimateRemoveTime, getAnimateRollOver, getAnimateRollUnder, getAnimateSelection, getAnimateSelectionUnder, getApplyFormulaAfterSummary, getApplyRowNumberStyle, getArrowKeyAction, getAsynchGroupingPrompt, getAutoComplete, getAutoConfirmSaveEdits, getAutoFetchAsFilter, getAutoFetchData, getAutoFetchDisplayMap, getAutoFitAllText, getAutoFitClipFields, getAutoFitData, getAutoFitExpandField, getAutoFitExtraRecords, getAutoFitFieldsFillViewport, getAutoFitFieldText, getAutoFitFieldWidths, getAutoFitHeaderHeights, getAutoFitIconFields, getAutoFitMaxColumns, getAutoFitMaxHeight, getAutoFitMaxRecords, getAutoFitMaxWidth, getAutoFitWidthApproach, getAutoSaveEdits, getAutoSizeHeaderSpans, getBackgroundComponent, getBadFormulaResultValue, getBaseStyle, getBody, getBodyBackgroundColor, getBodyOverflow, getBodyScrollLeft, getBodyScrollTop, getBooleanBaseStyle, getBooleanFalseImage, getBooleanImageHeight, getBooleanImageWidth, getBooleanPartialImage, getBooleanTrueImage, getCanAcceptDroppedRecords, getCanAddFormulaFields, getCanAddSummaryFields, getCanAutoFitFields, getCancelEditingConfirmationMessage, getCanCollapseGroup, getCanDragRecordsOut, getCanDragSelectText, getCanDropInEmptyArea, getCanEditFieldAttribute, getCanEditHilites, getCanEditTitles, getCanExpandMultipleRecords, getCanExpandRecordProperty, getCanExpandRecords, getCanFocusInEmptyGrid, getCanFreezeFields, getCanGroupBy, getCanHover, getCanMultiGroup, getCanMultiSort, getCanPickFields, getCanPickOmittedFields, getCanRemoveRecords, getCanReorderFields, getCanReorderRecords, getCanResizeFields, getCanSelectAll, getCanSelectCells, getCanSelectGroups, getCanSort, getCanTabToHeader, getCellContextMenu, getCellCSSText, getCellErrors, getCellHeight, getCellHoverComponent, getCellPadding, getCellPageRect, getCellRowSpan, getCellSelection, getCellStartRow, getCellStyle, getCheckboxFieldFalseImage, getCheckboxFieldImageHeight, getCheckboxFieldImageWidth, getCheckboxFieldPartialImage, getCheckboxFieldTrueImage, getChildExpansionMode, getClearAllSortingText, getClearFilterText, getClearSortFieldText, getClipHeaderTitles, getCollapseGroupOnRowClick, getColumnLeft, getColumnPageLeft, getColumnWidth, getConfigureGroupingText, getConfigureSortText, getConfirmCancelEditing, getConfirmDiscardEdits, getConfirmDiscardEditsMessage, getCriteria, getCurrentExpansionComponent, getCurrentExpansionComponent, getCurrentFieldWidths, getDataAsJSList, getDataAsRecordList, getDataFetchMode, getDataPageSize, getDataSource, getDateFormatter, getDatetimeFormatter, getDeepCloneOnEdit, getDefaultFields, getDefaultFormattedFieldValue, getDefaultFormattedFieldValue, getDefaultFormattedFieldValue, getDefaultFormattedValue, getDeferRemoval, getDetailDS, getDetailField, getDiscardEditsOnHideField, getDiscardEditsSaveButtonTitle, getDisplayValue, getDisplayValue, getDisplayValue, getDisplayValue, getDisplayValue, getDragData, getDragDataAction, getDragScrollRedrawDelay, getDragTrackerMode, getDragTrackerStyle, getDrawAheadRatio, getDrawAllMaxCells, getDrawArea, getDrawnRowHeight, getDrawnRows, getDropValues, getDuplicateDragMessage, getEditCol, getEditedCell, getEditedCell, getEditedCell, getEditedRecord, getEditEvent, getEditFailedBaseStyle, getEditFailedCSSText, getEditFormItem, getEditFormItem, getEditFormulaFieldText, getEditOnF2Keypress, getEditOnFocus, getEditPendingBaseStyle, getEditPendingCSSText, getEditProxyConstructor, getEditRow, getEditSummaryFieldText, getEditValue, getEditValueAsBoolean, getEditValueAsDate, getEditValueAsFloat, getEditValueAsInt, getEditValueAsRecord, getEditValueAsRecordArray, getEditValueAsString, getEditValues, getEditValues, getEmptyCellValue, getEmptyMessage, getEmptyMessageStyle, getEnforceVClipping, getEnterKeyEditAction, getEnumCriteriaAsInitialValues, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getEscapeKeyEditAction, getExpandedRecords, getExpansionCanEdit, getExpansionComponent, getExpansionComponentPoolingMode, getExpansionDetailField, getExpansionDetailRelated, getExpansionDetails, getExpansionEditor, getExpansionEditorCollapseOnSave, getExpansionEditorSaveButton, getExpansionEditorSaveButtonTitle, getExpansionEditorSaveDialogPrompt, getExpansionEditorShowSaveDialog, getExpansionField, getExpansionFieldFalseImage, getExpansionFieldImageHeight, getExpansionFieldImageWidth, getExpansionFieldTrueImage, getExpansionLayout, getExpansionMode, getExpansionRelated, getExportAll, getExportAlternateRowBGColor, getExportBGColor, getExportColumnBGColor, getExportDefaultBGColor, getExportFieldAlignments, getExportFields, getExportFieldWidths, getExportHeaderHeights, getExportRawValues, getExportRowBGColor, getExportWidthScale, getExportWrapHeaderTitles, getFetchDelay, getFetchOperation, getField, getField, getFieldAlignments, getFieldByName, getFieldContentWidth, getFieldCount, getFieldName, getFieldNum, getFieldNum, getFieldPickerFieldProperties, getFieldPickerShowSampleValues, getFieldPickerWindow, getFields, getFieldsAsJavaScriptObjects, getFieldState, getFieldTitle, getFieldTitle, getFieldVisibilitySubmenuTitle, getFieldWidth, getFieldWidth, getFilterButtonPrompt, getFilterButtonProperties, getFilterByCell, getFilterEditor, getFilterEditorCriteria, getFilterEditorCriteria, getFilterEditorCriteriaAsAdvancedCriteria, getFilterEditorHeight, getFilterEditorProperties, getFilterLocalData, getFilterOnKeypress, getFixedFieldWidths, getFixedRecordHeights, getFocusRow, getFormulaBuilderSpanTitleSeparator, getFormulaFieldValue, getFreezeFieldText, getFreezeOnLeftText, getFreezeOnRightText, getFrozenBaseStyle, getFrozenHeaderBaseStyle, getFrozenHeaderTitleStyle, getGenerateClickOnEnter, getGenerateClickOnSpace, getGenerateDoubleClickOnEnter, getGenerateDoubleClickOnSpace, getGridComponents, getGridRenderer, getGridSummary, getGridSummaryData, getGridSummaryRecordProperty, getGroupByAsyncThreshold, getGroupByFields, getGroupByFieldSummaries, getGroupByMaxRecords, getGroupByText, getGroupIcon, getGroupIconSize, getGroupIndentSize, getGroupLeadingIndent, getGroupNodeBaseStyle, getGroupNodeStyle, getGroupSortDirection, getGroupState, getGroupSummaryData, getGroupSummaryRecordProperty, getGroupSummaryStyle, getGroupTitleColumnProperties, getGroupTitleField, getGroupTree, getGroupTreeSelection, getGroupTreeSelection, getGroupTreeSelection, getHeader, getHeaderAutoFitEvent, getHeaderBackgroundColor, getHeaderBarStyle, getHeaderBaseStyle, getHeaderButtonProperties, getHeaderContextMenu, getHeaderContextMenuItems, getHeaderHeight, getHeaderHoverAlign, getHeaderHoverHeight, getHeaderHoverOpacity, getHeaderHoverStyle, getHeaderHoverVAlign, getHeaderHoverWidth, getHeaderHoverWrap, getHeaderMenuButton, getHeaderMenuButtonHeight, getHeaderMenuButtonIcon, getHeaderMenuButtonIconHeight, getHeaderMenuButtonIconWidth, getHeaderMenuButtonWidth, getHeaderSpan, getHeaderSpanContextMenuItems, getHeaderSpanHeight, getHeaderTitleStyle, getHideEmptySummaryRow, getHiliteCanReplaceValue, getHiliteEditorSpanTitleSeparator, getHiliteHTMLAfterFormat, getHiliteIconHeight, getHiliteIconLeftPadding, getHiliteIconPosition, getHiliteIconRightPadding, getHiliteIcons, getHiliteIconSize, getHiliteIconWidth, getHiliteProperty, getHiliteReplaceValueFieldTitle, getHiliteRowOnFocus, getHiliteState, getHoverMode, getHoverStyle, getIconPadding, getImageSize, getIncludeHilitesInSummaryFields, getIncludeInSummaryProperty, getInitialCriteria, getInitialSort, getInstantScrollTrackRedraw, getInvalidSummaryValue, getIsGrouped, getIsSeparatorProperty, getLeaveScrollbarGap, getLinkTextProperty, getListEndEditAction, getLoadingDataMessage, getLoadingDataMessageStyle, getLoadingMessage, getLocateColumnsBy, getLocateRowsBy, getLongTextEditorThreshold, getLongTextEditorType, getMaxExpandedRecords, getMaxExpandedRecordsPrompt, getMinFieldWidth, getMissingSummaryFieldValue, getModalEditing, getNavigateOnTab, getNeverValidate, getNormalBaseStyle, getNormalCellHeight, getNullGroupTitle, getOfflineMessageStyle, getOriginalRecordList, getOriginalResultSet, getOriginBaseStyle, getPoolComponentsPerColumn, getPreventDuplicates, getPrintAutoFit, getPrintBaseStyle, getPrintBooleanBaseStyle, getPrintBooleanFalseImage, getPrintBooleanPartialImage, getPrintBooleanTrueImage, getPrintCheckboxFieldFalseImage, getPrintCheckboxFieldPartialImage, getPrintCheckboxFieldTrueImage, getPrintHeaderStyle, getPrintMaxRows, getPrintWrapCells, getProgressiveLoading, getQuickDrawAheadRatio, getRecord, getRecordBaseStyleProperty, getRecordCanRemoveProperty, getRecordCanSelectProperty, getRecordComponent, getRecordComponent, getRecordComponentHeight, getRecordComponentPoolingMode, getRecordComponentPosition, getRecordDetailDSProperty, getRecordDropAppearance, getRecordDropPosition, getRecordEditProperty, getRecordEnabledProperty, getRecordIndex, getRecordIndex, getRecordList, getRecords, getRecordSummaryBaseStyle, getRelatedDataSource, getRemovedCSSText, getRemoveFieldDefaults, getRemoveFieldProperties, getRemoveFieldTitle, getRemoveIcon, getRemoveIconSize, getRemoveOperation, getReselectOnUpdate, getReselectOnUpdateNotifications, getResizeFieldsInRealTime, getResultSet, getReverseRTLAlign, getRollOverCanvas, getRollUnderCanvas, getRowEndEditAction, getRowErrors, getRowHeight, getRowNum, getRowNumberField, getRowNumberStart, getRowNumberStyle, getRowPageTop, getRowSpan, getRowSpanEditMode, getRowSpanSelectionMode, getRowTop, getSaveLocally, getSaveRequestProperties, getScreenReaderCellSeparator, getScreenReaderRowSeparator, getScrollRedrawDelay, getScrollToCellXPosition, getScrollToCellYPosition, getScrollWheelRedrawDelay, getSelectCellTextOnClick, getSelectedCellData, getSelectedRecord, getSelectedRecords, getSelectedRecords, getSelectedState, getSelectHeaderOnSort, getSelection, getSelection, getSelectionAppearance, getSelectionProperty, getSelectionType, getSelectOnEdit, getSelectOnExpandRecord, getShowAllColumns, getShowAllRecords, getShowAsynchGroupingPrompt, getShowBackgroundComponents, getShowCellContextMenus, getShowClippedHeaderTitlesOnHover, getShowClippedValuesOnHover, getShowCollapsedGroupSummary, getShowComplexFields, getShowDetailFields, getShowEmptyMessage, getShowErrorIcons, getShowExpansionEditorSaveButton, getShowFilterEditor, getShowGridSummary, getShowGroupSummary, getShowGroupSummaryInHeader, getShowGroupTitleColumn, getShowHeader, getShowHeaderContextMenu, getShowHeaderMenuButton, getShowHeaderSpanTitlesInFormulaBuilder, getShowHeaderSpanTitlesInHiliteEditor, getShowHeaderSpanTitlesInSortEditor, getShowHiddenFields, getShowHilitesInGroupSummary, getShowHover, getShowHoverComponents, getShowPartialSelection, getShowRecordComponents, getShowRecordComponentsByCell, getShowRollOver, getShowRollOverCanvas, getShowRollUnderCanvas, getShowRowNumbers, getShowSelectedStyle, getShowSelectionCanvas, getShowSelectionUnderCanvas, getShowSortArrow, getShowSortNumerals, getShowTreeColumnPicker, getShrinkForFreeze, getSingleCellValueProperty, getSort, getSortAscendingImage, getSortBinaryByFileName, getSortByGroupFirst, getSortDescendingImage, getSortEditorSpanTitleSeparator, getSorterButtonTitle, getSortField, getSortFieldAscendingText, getSortFieldCount, getSortFieldDescendingText, getSortNumeralHTML, getSortNumeralStyle, getSortSpecifier, getSortState, getSpanContextMenu, getStopOnErrors, getSummaryFieldValue, getSummaryRow, getSummaryRowCriteria, getSummaryRowDataSource, getSummaryRowFetchRequestProperties, getSummaryRowHeight, getSummaryRowStyle, getTallBaseStyle, getTestInstance, getTitleField, getTitleFieldValue, getToggleFreezeText, getTotalRows, getTrackerImage, getUnfreezeFieldText, getUngroupText, getUnremoveIcon, getUpdateOperation, getUseAdvancedFieldPicker, getUseAllDataSourceFields, getUseCellRollOvers, getUseCopyPasteShortcuts, getUseFlatFields, getUseRemoteValidators, getUseRowSpanStyling, getValidateByCell, getValidateOnChange, getValueIcon, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getViewState, getVirtualScrolling, getVisibleRows, getWaitForSave, getWarnOnRemoval, getWarnOnRemovalMessage, getWarnOnUnmappedValueFieldChange, getWrapCells, getWrapHeaderSpanTitles, getWrapHeaderTitles, groupBy, hasErrors, headerHoverHTML, headerTitleClipped, hideField, hideField, hideFields, hideFields, hideFields, hideFields, invalidateCache, invalidateRecordComponents, isCheckboxField, isExpanded, isExpansionField, isExportingClientData, isGrouped, isGroupNode, isPartiallySelected, isRowNumberField, isSelected, isSortField, markForRedraw, markForRedraw, markRecordRemoved, markRecordsRemoved, markRecordsRemoved, markRecordsRemoved, markSelectionRemoved, onInit_ListGrid, onInit, openGroup, openRecordDetailGrid, openRecordEditor, preloadImages, recalculateGridSummary, recalculateSummaries, recalculateSummaries, recalculateSummaries, recordClick, recordMarkedAsRemoved, redrawHeader, refreshCell, refreshCell, refreshCellStyle, refreshData, refreshData, refreshFields, refreshRecordComponent, refreshRecordComponent, refreshRow, regroup, removeData, removeData, removeData, removeEmbeddedComponent, removeEmbeddedComponent, removeEmbeddedComponent, removeRecordClick, removeSelectedData, removeSelectedData, removeSelectedData, reorderField, reorderFields, resizeField, resort, rowClick, rowClick, rowDoubleClick, rowDoubleClick, rowHasChanges, rowHasErrors, saveAllEdits, saveAllEdits, saveAllEdits, saveEdits, saveEdits, saveEdits, saveEdits, scrollBodyTo, scrollToCell, scrollToCell, scrollToCell, scrollToColumn, scrollToColumn, scrollToRow, scrollToRow, selectAllRecords, selectRange, selectRange, selectRecord, selectRecord, selectRecord, selectRecord, selectRecords, selectRecords, selectRecords, selectRecords, selectSingleRecord, selectSingleRecord, setAddDropValues, setAddFormulaFieldText, setAddOperation, setAddSummaryFieldText, setAdvancedFieldPickerThreshold, setAllowFilterExpressions, setAllowRowSpanning, setAlternateBodyStyleName, setAlternateFieldFrequency, setAlternateFieldStyles, setAlternateRecordFrequency, setAlwaysShowEditors, setAnimateFolderEffect, setAnimateFolderMaxRows, setAnimateFolders, setAnimateFolderSpeed, setAnimateFolderTime, setAnimateRemoveRecord, setAnimateRemoveSpeed, setAnimateRemoveTime, setAnimateRollOver, setAnimateRollUnder, setAnimateSelection, setAnimateSelectionUnder, setApplyFormulaAfterSummary, setApplyRowNumberStyle, setArrowKeyAction, setAsynchGroupingPrompt, setAutoComplete, setAutoConfirmSaveEdits, setAutoFetchAsFilter, setAutoFetchData, setAutoFetchDisplayMap, setAutoFitAllText, setAutoFitClipFields, setAutoFitData, setAutoFitExpandField, setAutoFitExtraRecords, setAutoFitFieldsFillViewport, setAutoFitFieldText, setAutoFitFieldWidths, setAutoFitHeaderHeights, setAutoFitIconFields, setAutoFitMaxColumns, setAutoFitMaxHeight, setAutoFitMaxRecords, setAutoFitMaxWidth, setAutoFitWidth, setAutoFitWidthApproach, setAutoSaveEdits, setAutoSizeHeaderSpans, setBadFormulaResultValue, setBodyBackgroundColor, setBodyOverflow, setBooleanBaseStyle, setBooleanFalseImage, setBooleanImageHeight, setBooleanImageWidth, setBooleanPartialImage, setBooleanTrueImage, setCanAcceptDroppedRecords, setCanAddFormulaFields, setCanAddSummaryFields, setCanAutoFitFields, setCancelEditingConfirmationMessage, setCanCollapseGroup, setCanDragRecordsOut, setCanDragSelectText, setCanDropInEmptyArea, setCanEditFieldAttribute, setCanEditHilites, setCanEditTitles, setCanExpandMultipleRecords, setCanExpandRecordProperty, setCanExpandRecords, setCanFocusInEmptyGrid, setCanFreezeFields, setCanGroupBy, setCanHover, setCanMultiGroup, setCanMultiSort, setCanPickFields, setCanPickOmittedFields, setCanRemoveRecords, setCanReorderFields, setCanReorderRecords, setCanResizeFields, setCanSelectAll, setCanSelectCells, setCanSelectGroups, setCanSort, setCanTabToHeader, setCellFormatter, setCellHeight, setCellPadding, setCellValueHoverFormatter, setCheckboxFieldFalseImage, setCheckboxFieldImageHeight, setCheckboxFieldImageWidth, setCheckboxFieldPartialImage, setCheckboxFieldProperties, setCheckboxFieldTrueImage, setChildExpansionMode, setClearAllSortingText, setClearFilterText, setClearSortFieldText, setClipHeaderTitles, setCollapseGroupOnRowClick, setConfigureGroupingText, setConfigureSortText, setConfirmCancelEditing, setConfirmDiscardEdits, setConfirmDiscardEditsMessage, setCriteria, setData, setData, setData, setDataFetchMode, setDataPageSize, setDataProperties, setDataSource, setDataSource, setDataSource, setDateFormatter, setDateInputFormat, setDatetimeFormatter, setDeepCloneOnEdit, setDefaultFields, setDefaultFieldWidthCustomizer, setDefaultProperties, setDeferRemoval, setDetailDS, setDetailDS, setDetailField, setDiscardEditsOnHideField, setDiscardEditsSaveButtonTitle, setDontAutoDestroyComponent, setDragDataAction, setDragScrollRedrawDelay, setDragTrackerIconCustomizer, setDragTrackerMode, setDragTrackerStyle, setDragTrackerTitleCustomizer, setDrawAheadRatio, setDrawAllMaxCells, setDropValues, setDuplicateDragMessage, setEditByCell, setEditEvent, setEditFailedBaseStyle, setEditFailedCSSText, setEditFormulaFieldText, setEditOnF2Keypress, setEditOnFocus, setEditorCustomizer, setEditorValueMap, setEditorValueMap, setEditPendingBaseStyle, setEditPendingCSSText, setEditProxyConstructor, setEditSummaryFieldText, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValue, setEditValues, setEmptyCellValue, setEmptyMessage, setEmptyMessageStyle, setEnforceVClipping, setEnterKeyEditAction, setEnumCriteriaAsInitialValues, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setEscapeKeyEditAction, setExpansionCanEdit, setExpansionComponentPoolingMode, setExpansionEditorSaveDialogPrompt, setExpansionEditorShowSaveDialog, setExpansionFieldFalseImage, setExpansionFieldImageHeight, setExpansionFieldImageWidth, setExpansionFieldTrueImage, setExpansionMode, setExportAll, setExportAlternateRowBGColor, setExportDefaultBGColor, setExportFieldAlignments, setExportFields, setExportFieldWidths, setExportHeaderHeights, setExportRawValues, setExportWidthScale, setExportWrapHeaderTitles, setFastCellUpdates, setFetchDelay, setFetchOperation, setFieldButtonProperties, setFieldCellIcon, setFieldError, setFieldError, setFieldHeaderBaseStyle, setFieldHeaderTitleStyle, setFieldIcon, setFieldPickerFieldProperties, setFieldPickerShowSampleValues, setFieldProperties, setFieldProperties, setFields, setFields, setFieldState, setFieldTitle, setFieldTitle, setFieldVisibilitySubmenuTitle, setFilterButtonPrompt, setFilterButtonProperties, setFilterByCell, setFilterEditorCriteria, setFilterEditorHeight, setFilterEditorProperties, setFilterEditorProperties, setFilterLocalData, setFilterOnKeypress, setFixedFieldWidths, setFixedRecordHeights, setFormulaBuilderSpanTitleSeparator, setFreezeFieldText, setFreezeOnLeftText, setFreezeOnRightText, setFrozenBaseStyle, setFrozenHeaderBaseStyle, setFrozenHeaderTitleStyle, setGenerateClickOnEnter, setGenerateClickOnSpace, setGenerateDoubleClickOnEnter, setGenerateDoubleClickOnSpace, setGridComponents, setGridComponents, setGridSummaryRecordProperty, setGroupByAsyncThreshold, setGroupByField, setGroupByField, setGroupByFieldSummaries, setGroupByMaxRecords, setGroupByText, setGroupIcon, setGroupIconSize, setGroupIndentSize, setGroupLeadingIndent, setGroupNodeBaseStyle, setGroupNodeStyle, setGroupSortDirection, setGroupStartOpen, setGroupStartOpen, setGroupState, setGroupSummaryRecordProperty, setGroupSummaryStyle, setGroupTitleColumnProperties, setGroupTitleField, setHeaderAutoFitEvent, setHeaderBackgroundColor, setHeaderBarStyle, setHeaderBaseStyle, setHeaderButtonProperties, setHeaderHeight, setHeaderHoverAlign, setHeaderHoverFormatter, setHeaderHoverHeight, setHeaderHoverOpacity, setHeaderHoverStyle, setHeaderHoverVAlign, setHeaderHoverWidth, setHeaderHoverWrap, setHeaderMenuButtonHeight, setHeaderMenuButtonIcon, setHeaderMenuButtonIconHeight, setHeaderMenuButtonIconWidth, setHeaderMenuButtonWidth, setHeaderSpanBaseStyle, setHeaderSpanButtonProperties, setHeaderSpanHeaderTitle, setHeaderSpanHeight, setHeaderSpans, setHeaderSpanTitle, setHeaderSpanTitleStyle, setHeaderTitleStyle, setHideEmptySummaryRow, setHiliteCanReplaceValue, setHiliteEditorSpanTitleSeparator, setHiliteHTMLAfterFormat, setHiliteIconHeight, setHiliteIconLeftPadding, setHiliteIconPosition, setHiliteIconRightPadding, setHiliteIcons, setHiliteIconSize, setHiliteIconWidth, setHiliteProperty, setHiliteReplaceValueFieldTitle, setHiliteRowOnFocus, setHiliteState, setHoverCustomizer, setHoverMode, setHoverStyle, setIconPadding, setImageSize, setIncludeHilitesInSummaryFields, setIncludeInSummaryProperty, setInitialCriteria, setInitialSort, setInstantScrollTrackRedraw, setInvalidSummaryValue, setIsSeparatorProperty, setLeaveHeaderMenuButtonSpace, setLeaveScrollbarGap, setLinkTextProperty, setListEndEditAction, setLoadingDataMessage, setLoadingDataMessageStyle, setLoadingMessage, setLocateColumnsBy, setLocateRowsBy, setLogicalStructure, setLongTextEditorThreshold, setLongTextEditorType, setMaxExpandedRecords, setMaxExpandedRecordsPrompt, setMinFieldWidth, setMissingSummaryFieldValue, setModalEditing, setNavigateOnTab, setNeverValidate, setNormalBaseStyle, setNormalCellHeight, setNullGroupTitle, setOfflineMessageStyle, setOriginBaseStyle, setPoolComponentsPerColumn, setPreventDuplicates, setPrintAutoFit, setPrintBaseStyle, setPrintBooleanBaseStyle, setPrintBooleanFalseImage, setPrintBooleanPartialImage, setPrintBooleanTrueImage, setPrintCheckboxFieldFalseImage, setPrintCheckboxFieldPartialImage, setPrintCheckboxFieldTrueImage, setPrintHeaderStyle, setPrintMaxRows, setPrintWrapCells, setProgressiveLoading, setQuickDrawAheadRatio, setRecordBaseStyleProperty, setRecordCanRemoveProperty, setRecordCanSelectProperty, setRecordComponentHeight, setRecordComponentPoolingMode, setRecordComponentPosition, setRecordDetailDSProperty, setRecordDropAppearance, setRecordEditProperty, setRecordEnabledProperty, setRecords, setRecordSummaryBaseStyle, setRemovedCSSText, setRemoveFieldProperties, setRemoveFieldTitle, setRemoveIcon, setRemoveIconSize, setRemoveOperation, setReselectOnUpdate, setReselectOnUpdateNotifications, setResizeFieldsInRealTime, setReverseRTLAlign, setRollOverCanvasProperties, setRollUnderCanvasProperties, setRowEndEditAction, setRowErrors, setRowErrors, setRowNumberFieldProperties, setRowNumberStart, setRowNumberStyle, setRowSpanEditMode, setRowSpanSelectionMode, setSaveByCell, setSaveLocally, setSaveRequestProperties, setScreenReaderCellSeparator, setScreenReaderRowSeparator, setScrollRedrawDelay, setScrollToCellXPosition, setScrollToCellYPosition, setScrollWheelRedrawDelay, setSelectCellTextOnClick, setSelectedState, setSelectHeaderOnSort, setSelectionAppearance, setSelectionCanvasProperties, setSelectionProperty, setSelectionType, setSelectionUnderCanvasProperties, setSelectOnEdit, setSelectOnExpandRecord, setShowAllColumns, setShowAllRecords, setShowAsynchGroupingPrompt, setShowBackgroundComponents, setShowCellContextMenus, setShowClippedHeaderTitlesOnHover, setShowClippedValuesOnHover, setShowCollapsedGroupSummary, setShowComplexFields, setShowDetailFields, setShowEmptyMessage, setShowErrorIcons, setShowFilterEditor, setShowGridSummary, setShowGroupSummary, setShowGroupSummaryInHeader, setShowGroupTitleColumn, setShowHeader, setShowHeaderContextMenu, setShowHeaderMenuButton, setShowHeaderSpanTitlesInFormulaBuilder, setShowHeaderSpanTitlesInHiliteEditor, setShowHeaderSpanTitlesInSortEditor, setShowHiddenFields, setShowHilitesInGroupSummary, setShowHover, setShowHoverComponents, setShowPartialSelection, setShowRecordComponents, setShowRecordComponentsByCell, setShowRollOver, setShowRollOverCanvas, setShowRollUnderCanvas, setShowRowNumbers, setShowSelectedStyle, setShowSelectionCanvas, setShowSelectionUnderCanvas, setShowSortArrow, setShowSortNumerals, setShowTreeColumnPicker, setShrinkForFreeze, setSingleCellValueProperty, setSort, setSortAscendingImage, setSortBinaryByFileName, setSortByGroupFirst, setSortDescendingImage, setSortEditorSpanTitleSeparator, setSorterButtonTitle, setSortField, setSortField, setSortField, setSortFieldAscendingText, setSortFieldDescendingText, setSortNumeralHTMLCustomizer, setSortNumeralStyle, setSortState, setStopOnErrors, setSummaryRowCriteria, setSummaryRowDataSource, setSummaryRowFetchRequestProperties, setSummaryRowHeight, setSummaryRowStyle, setTallBaseStyle, setTitleField, setTrackerImage, setUnfreezeFieldText, setUngroupText, setUnremoveIcon, setUpdateOperation, setUseAdvancedFieldPicker, setUseAllDataSourceFields, setUseCellRollOvers, setUseCopyPasteShortcuts, setUseFlatFields, setUseRemoteValidators, setUserFormula, setUserFormula, setUserFormula, setUserFormulaText, setUserFormulaText, setUserFormulaText, setUseRowSpanStyling, setUserSummary, setUserSummary, setUserSummary, setUserSummaryText, setUserSummaryText, setUserSummaryText, setValidateByCell, setValidateOnChange, setValueIconHeight, setValueIconLeftPadding, setValueIconRightPadding, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setViewState, setVirtualScrolling, setWaitForSave, setWarnOnRemoval, setWarnOnRemovalMessage, setWarnOnUnmappedValueFieldChange, setWrapCells, setWrapHeaderSpanTitles, setWrapHeaderTitles, shouldIncludeHiliteInSummaryField, showField, showField, showFields, showFields, showFields, showFields, showRecordComponent, sort, sort, sort, sort, startEditing, startEditing, startEditing, startEditing, startEditingNew, startEditingNew, startEditingNew, startEditingNew, stopHover, summaryUpdated, toggleSort, transferSelectedData, transferSelectedData, unfreezeField, unfreezeField, unfreezeField, unfreezeField, unfreezeFields, unfreezeFields, ungroup, unmarkRecordRemoved, unsort, updateData, updateData, updateData, updateRecordComponent, userSelectAllRecords, validateCell, validateCell, validateRow, willAcceptDrop, willFetchData, willFetchData`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutTopMargin, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersLength, getMembersMargin, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutTopMargin, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, encloses, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoMaskComponents, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeavePageSpace, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getTabIndex, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseDragMask, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, printComponents, provideRuleContext, redraw, redraw, removeChild, removeChild, removePeer, removePeer, removeSnapAlignCandidate, resizeBy, resizeTo, resizeTo, revealChild, revealChild, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAllowExternalFilters, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoMaskComponents, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeavePageSpace, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setTabIndex, setTitle, setTooltip, setTop, setTop, setUseBackMask, setUseDragMask, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateEditNode, updateHover, updateHover, updateShadow, visibleAtPoint`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, applyFactoryProperties, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

    - ### Methods inherited from interface com.smartgwt.client.widgets.DataBoundComponent

      `getOrCreateJsObj`

- - ### Constructor Detail

    - #### CubeGrid

          public CubeGrid()

    - #### CubeGrid

          public CubeGrid(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static CubeGrid getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `ListGrid`

    - #### setAlternateRecordStyles

          public void setAlternateRecordStyles(java.lang.Boolean alternateRecordStyles)

      Whether alternating rows should be drawn in alternating styles, in order to create a "ledger" effect for easier reading. If enabled, the cell style for alternate rows will have "Dark" appended to it.
      Overrides:
        `setAlternateRecordStyles` in class `ListGrid`
      Parameters:
        `alternateRecordStyles` - Default value is true
      See Also:
        `Appearance overview and related methods`

    - #### getAlternateRecordStyles

          public java.lang.Boolean getAlternateRecordStyles()

      Whether alternating rows should be drawn in alternating styles, in order to create a "ledger" effect for easier reading. If enabled, the cell style for alternate rows will have "Dark" appended to it.
      Overrides:
        `getAlternateRecordStyles` in class `ListGrid`
      Returns:
        Boolean
      See Also:
        `Appearance overview and related methods`

    - #### setAutoFetchTextMatchStyle

          public void setAutoFetchTextMatchStyle(TextMatchStyle autoFetchTextMatchStyle)
                                          throws java.lang.IllegalStateException

      If `autoFetchData` is `true`, this attribute allows the developer to specify a textMatchStyle for the initial `fetchData()` call.
      Specified by:
        `setAutoFetchTextMatchStyle` in interface `DataBoundComponent`
      Overrides:
        `setAutoFetchTextMatchStyle` in class `ListGrid`
      Parameters:
        `autoFetchTextMatchStyle` - Default value is "exact"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Databinding overview and related methods`

    - #### getAutoFetchTextMatchStyle

          public TextMatchStyle getAutoFetchTextMatchStyle()

      If `autoFetchData` is `true`, this attribute allows the developer to specify a textMatchStyle for the initial `fetchData()` call.
      Specified by:
        `getAutoFetchTextMatchStyle` in interface `DataBoundComponent`
      Overrides:
        `getAutoFetchTextMatchStyle` in class `ListGrid`
      Returns:
        TextMatchStyle
      See Also:
        `Databinding overview and related methods`

    - #### setAutoSelectHeaders

          public void setAutoSelectHeaders(java.lang.Boolean autoSelectHeaders)

      If true, when multiple facets appear on one side in a nested headers presentation, the selection state of parent/child headers are automatically kept in sync.
      Parameters:
        `autoSelectHeaders` - Default value is true

    - #### getAutoSelectHeaders

          public java.lang.Boolean getAutoSelectHeaders()

      If true, when multiple facets appear on one side in a nested headers presentation, the selection state of parent/child headers are automatically kept in sync.
      Returns:
        Boolean

    - #### setAutoSelectValues

          public void setAutoSelectValues(AutoSelectionModel autoSelectValues)
                                   throws java.lang.IllegalStateException

      Whether to select cells in the body when row or column headers are selected.
      Parameters:
        `autoSelectValues` - Default value is "both"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getAutoSelectValues

          public AutoSelectionModel getAutoSelectValues()

      Whether to select cells in the body when row or column headers are selected.
      Returns:
        AutoSelectionModel

    - #### setAutoSizeHeaders

          public void setAutoSizeHeaders(java.lang.Boolean autoSizeHeaders)

      Automatically size row headers to fit wrapped text.
      Parameters:
        `autoSizeHeaders` - Default value is false

    - #### getAutoSizeHeaders

          public java.lang.Boolean getAutoSizeHeaders()

      Automatically size row headers to fit wrapped text.
      Returns:
        Boolean

    - #### setBaseStyle

          public void setBaseStyle(java.lang.String baseStyle)
                            throws java.lang.IllegalStateException

      `base cell style` for this listGrid. If this property is unset, base style may be derived from `ListGrid.normalBaseStyle` or `ListGrid.tallBaseStyle` as described in `ListGrid.getBaseStyle()`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles.

      Overrides:
        `setBaseStyle` in class `ListGrid`
      Parameters:
        `baseStyle` - See `CSSStyleName` . Default value is "cubeCell"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getBaseStyle

          public java.lang.String getBaseStyle()

      `base cell style` for this listGrid. If this property is unset, base style may be derived from `ListGrid.normalBaseStyle` or `ListGrid.tallBaseStyle` as described in `ListGrid.getBaseStyle()`.

      See `CellStyleSuffixes` for details on how stateful suffixes are combined with the base style to generate stateful cell styles.

      Overrides:
        `getBaseStyle` in class `ListGrid`
      Returns:
        Return the base stylename for this cell. Default implementation just returns this.baseStyle. See `getCellStyle()` for a general discussion of how to style cells. See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setBodyMinHeight

          public void setBodyMinHeight(java.lang.Integer bodyMinHeight)

      Minimum height for the body of this cubeGrid.

      Note : This is an advanced setting

      Parameters:
        `bodyMinHeight` - Default value is null

    - #### getBodyMinHeight

          public java.lang.Integer getBodyMinHeight()

      Minimum height for the body of this cubeGrid.
      Returns:
        Integer

    - #### setBodyMinWidth

          public void setBodyMinWidth(java.lang.Integer bodyMinWidth)

      Minimum width for the body of this cubeGrid.

      Note : This is an advanced setting

      Parameters:
        `bodyMinWidth` - Default value is null

    - #### getBodyMinWidth

          public java.lang.Integer getBodyMinWidth()

      Minimum width for the body of this cubeGrid.
      Returns:
        Integer

    - #### setBodyStyleName

          public void setBodyStyleName(java.lang.String bodyStyleName)

      CSS class for the CubeGrid body
      Overrides:
        `setBodyStyleName` in class `ListGrid`
      Parameters:
        `bodyStyleName` - See `CSSStyleName` . Default value is "cubeGridBody"
      See Also:
        `Appearance overview and related methods`

    - #### getBodyStyleName

          public java.lang.String getBodyStyleName()

      CSS class for the CubeGrid body
      Overrides:
        `getBodyStyleName` in class `ListGrid`
      Returns:
        See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setCanCollapseFacets

          public void setCanCollapseFacets(java.lang.Boolean canCollapseFacets)

      If true, hierarchical facets will show expand/collapse controls to allow the user to expand and collapse the tree of facetValues for that facet.
      Parameters:
        `canCollapseFacets` - Default value is false

    - #### getCanCollapseFacets

          public java.lang.Boolean getCanCollapseFacets()

      If true, hierarchical facets will show expand/collapse controls to allow the user to expand and collapse the tree of facetValues for that facet.
      Returns:
        Boolean

    - #### setCanDragSelect

          public void setCanDragSelect(java.lang.Boolean canDragSelect)
                                throws java.lang.IllegalStateException

      For `touch browsers`, `canDragSelect` defaults to false so that touch scrolling can be used to navigate scrollable CubeGrids. In all other browsers it defaults to true.

      NOTE: If `canDragSelect` is enabled, it may be desirable to disable `touch scrolling` so that touch-dragging cells of the CubeGrid selects them rather than starting a scroll. If `Canvas.disableTouchScrollingForDrag` is set to `true`, then touch scrolling will be disabled automatically. However, for `accessibility` reasons, it is recommended to leave touch scrolling enabled and provide an alternative set of controls that can be used to perform drag-selection.

      Overrides:
        `setCanDragSelect` in class `ListGrid`
      Parameters:
        `canDragSelect` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Selection overview and related methods`, Drag list (select) Example

    - #### getCanDragSelect

          public java.lang.Boolean getCanDragSelect()

      For `touch browsers`, `canDragSelect` defaults to false so that touch scrolling can be used to navigate scrollable CubeGrids. In all other browsers it defaults to true.

      NOTE: If `canDragSelect` is enabled, it may be desirable to disable `touch scrolling` so that touch-dragging cells of the CubeGrid selects them rather than starting a scroll. If `Canvas.disableTouchScrollingForDrag` is set to `true`, then touch scrolling will be disabled automatically. However, for `accessibility` reasons, it is recommended to leave touch scrolling enabled and provide an alternative set of controls that can be used to perform drag-selection.

      Overrides:
        `getCanDragSelect` in class `ListGrid`
      Returns:
        Boolean
      See Also:
        `Selection overview and related methods`, Drag list (select) Example

    - #### setCanEdit

          public void setCanEdit(java.lang.Boolean canEdit)

      Whether cells can be edited in this grid. Can be overridden on a per-facetValue basis.
      Overrides:
        `setCanEdit` in class `ListGrid`
      Parameters:
        `canEdit` - Default value is false
      See Also:
        `ListGrid.startEditing()`, `ListGridField.setCanEdit(java.lang.Boolean)`, `ListGrid.setRecordEditProperty(java.lang.String)`, `ListGrid.canEditCell(int, int)`, `ListGrid.setFields(com.smartgwt.client.widgets.grid.ListGridField...)`, `Editing overview and related methods`, Edit by row Example

    - #### getCanEdit

          public java.lang.Boolean getCanEdit()

      Whether cells can be edited in this grid. Can be overridden on a per-facetValue basis.
      Overrides:
        `getCanEdit` in class `ListGrid`
      Returns:
        Boolean
      See Also:
        `ListGrid.startEditing()`, `ListGridField.getCanEdit()`, `ListGrid.getRecordEditProperty()`, `ListGrid.canEditCell(int, int)`, `ListGrid.getFields()`, `Editing overview and related methods`, Edit by row Example

    - #### setCanMinimizeColumns

          public void setCanMinimizeColumns(java.lang.Boolean canMinimizeColumns)

      If true, allow columns in the grid body to be minimized (reduced to the width of the minimize control) by clicking on a minimize control in the innermost column headers.
      Parameters:
        `canMinimizeColumns` - Default value is null

    - #### getCanMinimizeColumns

          public java.lang.Boolean getCanMinimizeColumns()

      If true, allow columns in the grid body to be minimized (reduced to the width of the minimize control) by clicking on a minimize control in the innermost column headers.
      Returns:
        Boolean

    - #### setCanMinimizeFacets

          public void setCanMinimizeFacets(java.lang.Boolean canMinimizeFacets)

      If true, when multiple facets are shown on a side, all facetValues in the second level of headers or higher will show controls to "minimize" the values of the next facet. Minimizing means showing only one, or very few, of the next facet's values.

      Set `FacetValue.isMinimizeValue` to indicate which facetValues should be shown when a facet is minimized.

      Parameters:
        `canMinimizeFacets` - Default value is false

    - #### getCanMinimizeFacets

          public java.lang.Boolean getCanMinimizeFacets()

      If true, when multiple facets are shown on a side, all facetValues in the second level of headers or higher will show controls to "minimize" the values of the next facet. Minimizing means showing only one, or very few, of the next facet's values.

      Set `FacetValue.isMinimizeValue` to indicate which facetValues should be shown when a facet is minimized.

      Returns:
        Boolean

    - #### setCanMoveFacets

          public void setCanMoveFacets(java.lang.Boolean canMoveFacets)

      Whether row and column facets can be rearranged by the user, by dragging and dropping the facet labels.
      Parameters:
        `canMoveFacets` - Default value is false

    - #### getCanMoveFacets

          public java.lang.Boolean getCanMoveFacets()

      Whether row and column facets can be rearranged by the user, by dragging and dropping the facet labels.
      Returns:
        Boolean

    - #### setCanReorderColumns

          public void setCanReorderColumns(java.lang.Boolean canReorderColumns)

      If true, body columns can be reordered via the innermost column headers.
      Parameters:
        `canReorderColumns` - Default value is null

    - #### getCanReorderColumns

          public java.lang.Boolean getCanReorderColumns()

      If true, body columns can be reordered via the innermost column headers.
      Returns:
        Boolean

    - #### setCanResizeColumns

          public void setCanResizeColumns(java.lang.Boolean canResizeColumns)

      If true, body columns can be resized via the innermost column headers.
      Parameters:
        `canResizeColumns` - Default value is null

    - #### getCanResizeColumns

          public java.lang.Boolean getCanResizeColumns()

      If true, body columns can be resized via the innermost column headers.
      Returns:
        Boolean

    - #### setCanSelectHeaders

          public void setCanSelectHeaders(java.lang.Boolean canSelectHeaders)

      Determines whether row or column facetValue headers can be selected.
      Parameters:
        `canSelectHeaders` - Default value is true

    - #### getCanSelectHeaders

          public java.lang.Boolean getCanSelectHeaders()

      Determines whether row or column facetValue headers can be selected.
      Returns:
        Boolean

    - #### setCanSelectValues

          public void setCanSelectValues(java.lang.Boolean canSelectValues)

      Determines whether cell values in the body can be selected.
      Parameters:
        `canSelectValues` - Default value is true

    - #### getCanSelectValues

          public java.lang.Boolean getCanSelectValues()

      Determines whether cell values in the body can be selected.
      Returns:
        Boolean

    - #### setCanSortData

          public void setCanSortData(java.lang.Boolean canSortData)

      If true, sort controls will be shown on facet values.

      When clicked, sort controls call `CubeGrid.sortByFacetValues()`.

      Parameters:
        `canSortData` - Default value is null

    - #### getCanSortData

          public java.lang.Boolean getCanSortData()

      If true, sort controls will be shown on facet values.

      When clicked, sort controls call `CubeGrid.sortByFacetValues()`.

      Returns:
        Boolean

    - #### setCanSortFacets

          public void setCanSortFacets(java.lang.Boolean canSortFacets)

      If true, sort controls will be shown on FacetHeaders.

      When clicked, sort controls call `CubeGrid.sortByFacetId()`.

      Parameters:
        `canSortFacets` - Default value is null

    - #### getCanSortFacets

          public java.lang.Boolean getCanSortFacets()

      If true, sort controls will be shown on FacetHeaders.

      When clicked, sort controls call `CubeGrid.sortByFacetId()`.

      Returns:
        Boolean

    - #### setCellAlign

          public void setCellAlign(Alignment cellAlign)

      Default align for cell values (in body).
      Parameters:
        `cellAlign` - Default value is "center"

    - #### getCellAlign

          public Alignment getCellAlign()

      Default align for cell values (in body).
      Returns:
        Alignment

    - #### setCellIdProperty

          public void setCellIdProperty(java.lang.String cellIdProperty)
                                 throws java.lang.IllegalStateException

      Name of the property in a cell record that holds it's unique ID. Note cell record IDs are optional.
      Parameters:
        `cellIdProperty` - Default value is "ID"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getCellIdProperty

          public java.lang.String getCellIdProperty()

      Name of the property in a cell record that holds it's unique ID. Note cell record IDs are optional.
      Returns:
        String

    - #### setChartConfirmThreshold

          public void setChartConfirmThreshold(int chartConfirmThreshold)
                                        throws java.lang.IllegalStateException

      If `makeChart()` is called with a chart specification that will show more than `chartConfirmThreshold` data elements, the user will be presented with a `confirmation dialog`.

      Set to 0 to disable this confirmation.

      Parameters:
        `chartConfirmThreshold` - Default value is 2000
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getChartConfirmThreshold

          public int getChartConfirmThreshold()

      If `makeChart()` is called with a chart specification that will show more than `chartConfirmThreshold` data elements, the user will be presented with a `confirmation dialog`.

      Set to 0 to disable this confirmation.

      Returns:
        int

    - #### setChartConstructor

          public void setChartConstructor(java.lang.String chartConstructor)
                                   throws java.lang.IllegalStateException

      Name of the Smart GWT Class to be used when creating charts. Must support the Chart interface.
      Overrides:
        `setChartConstructor` in class `ListGrid`
      Parameters:
        `chartConstructor` - Default value is "FacetChart"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getChartConstructor

          public java.lang.String getChartConstructor()

      Name of the Smart GWT Class to be used when creating charts. Must support the Chart interface.
      Overrides:
        `getChartConstructor` in class `ListGrid`
      Returns:
        String

    - #### setChartType

          public void setChartType(ChartType chartType)

      Default type of chart to plot.
      Overrides:
        `setChartType` in class `ListGrid`
      Parameters:
        `chartType` - Default value is "Column"

    - #### getChartType

          public ChartType getChartType()

      Default type of chart to plot.
      Overrides:
        `getChartType` in class `ListGrid`
      Returns:
        ChartType

    - #### setColHeaderBaseStyle

          public void setColHeaderBaseStyle(java.lang.String colHeaderBaseStyle)
                                     throws java.lang.IllegalStateException

      `baseStyle` for the buttons in this grid's column headers.

      Exception: The innermost column header will always be styled using `innerHeaderBaseStyle`.

      Parameters:
        `colHeaderBaseStyle` - See `CSSStyleName` . Default value is colHeader
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getColHeaderBaseStyle

          public java.lang.String getColHeaderBaseStyle()

      `baseStyle` for the buttons in this grid's column headers.

      Exception: The innermost column header will always be styled using `innerHeaderBaseStyle`.

      Returns:
        See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setColumnFacets

          public void setColumnFacets(java.lang.String... columnFacets)
                               throws java.lang.IllegalStateException

      The list of `ids` for facets that will appear on top of the body.
      Parameters:
        `columnFacets` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getColumnFacets

          public java.lang.String[] getColumnFacets()

      The list of `ids` for facets that will appear on top of the body.
      Returns:
        String...

    - #### setDefaultFacetWidth

          public void setDefaultFacetWidth(int defaultFacetWidth)

      Default width of inner column headers.
      Parameters:
        `defaultFacetWidth` - Default value is 100

    - #### getDefaultFacetWidth

          public int getDefaultFacetWidth()

      Default width of inner column headers.
      Returns:
        int

    - #### getEditByCell

          public java.lang.Boolean getEditByCell()
                                          throws java.lang.IllegalStateException

      CubeGrids only support editing by cell.

      Note : This method should be called only after the widget has been rendered.

      Overrides:
        `getEditByCell` in class `ListGrid`
      Returns:
        Boolean
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.
      See Also:
        `ListGrid.getCanEdit()`, `Editing overview and related methods`, Edit by cell Example

    - #### setExportColumnFacetBGColor

          public void setExportColumnFacetBGColor(java.lang.String exportColumnFacetBGColor)
                                           throws java.lang.IllegalStateException

      Sets the background color for the column headers of the cube. See also `ExportBGColor`.
      Parameters:
        `exportColumnFacetBGColor` - See `CSSColor` . Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExportColumnFacetBGColor

          public java.lang.String getExportColumnFacetBGColor()

      Sets the background color for the column headers of the cube. See also `ExportBGColor`.
      Returns:
        See `CSSColor`

    - #### setExportColumnFacetTextColor

          public void setExportColumnFacetTextColor(java.lang.String exportColumnFacetTextColor)
                                             throws java.lang.IllegalStateException

      Sets the text color for the column headers of the cube.
      Parameters:
        `exportColumnFacetTextColor` - See `CSSColor` . Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExportColumnFacetTextColor

          public java.lang.String getExportColumnFacetTextColor()

      Sets the text color for the column headers of the cube.
      Returns:
        See `CSSColor`

    - #### setExportFacetBGColor

          public void setExportFacetBGColor(java.lang.String exportFacetBGColor)
                                     throws java.lang.IllegalStateException

      Sets the background color for the row and column headers of the cube, if not otherwise set by a more specific property. (see `exportRowFacetBGColor()` and `exportColumnFacetBGColor()`). See also `ExportBGColor`.
      Parameters:
        `exportFacetBGColor` - See `CSSColor` . Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExportFacetBGColor

          public java.lang.String getExportFacetBGColor()

      Sets the background color for the row and column headers of the cube, if not otherwise set by a more specific property. (see `exportRowFacetBGColor()` and `exportColumnFacetBGColor()`). See also `ExportBGColor`.
      Returns:
        See `CSSColor`

    - #### setExportFacetSeparatorString

          public void setExportFacetSeparatorString(java.lang.String exportFacetSeparatorString)

      Default separator string used by `exportClientData()` to separate column and row facet value titles.

      Note : This is an advanced setting

      Parameters:
        `exportFacetSeparatorString` - Default value is " - "

    - #### getExportFacetSeparatorString

          public java.lang.String getExportFacetSeparatorString()

      Default separator string used by `exportClientData()` to separate column and row facet value titles.
      Returns:
        String

    - #### setExportFacetTextColor

          public void setExportFacetTextColor(java.lang.String exportFacetTextColor)
                                       throws java.lang.IllegalStateException

      Sets the text color for the row and column headers of the cube, if not otherwise set by a more specific property. (see `exportRowFacetTextColor()` and `exportColumnFacetTextColor()`).
      Parameters:
        `exportFacetTextColor` - See `CSSColor` . Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExportFacetTextColor

          public java.lang.String getExportFacetTextColor()

      Sets the text color for the row and column headers of the cube, if not otherwise set by a more specific property. (see `exportRowFacetTextColor()` and `exportColumnFacetTextColor()`).
      Returns:
        See `CSSColor`

    - #### setExportRowFacetBGColor

          public void setExportRowFacetBGColor(java.lang.String exportRowFacetBGColor)
                                        throws java.lang.IllegalStateException

      Sets the background color for the row headers of the cube. See also `ExportBGColor`.
      Parameters:
        `exportRowFacetBGColor` - See `CSSColor` . Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExportRowFacetBGColor

          public java.lang.String getExportRowFacetBGColor()

      Sets the background color for the row headers of the cube. See also `ExportBGColor`.
      Returns:
        See `CSSColor`

    - #### setExportRowFacetTextColor

          public void setExportRowFacetTextColor(java.lang.String exportRowFacetTextColor)
                                          throws java.lang.IllegalStateException

      Sets the text color for the row headers of the cube.
      Parameters:
        `exportRowFacetTextColor` - See `CSSColor` . Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getExportRowFacetTextColor

          public java.lang.String getExportRowFacetTextColor()

      Sets the text color for the row headers of the cube.
      Returns:
        See `CSSColor`

    - #### setFacetLabelHoverAlign

          public void setFacetLabelHoverAlign(Alignment facetLabelHoverAlign)

      Allows the developer to override the horizontal text alignment of hover tips shown for facetLabels. If unspecified the hover canvas content alignment will be set by `this.hoverAlign` if specified.

      Note : This is an advanced setting

      Parameters:
        `facetLabelHoverAlign` - Default value is null
      See Also:
        `Canvas.setHoverAlign(com.smartgwt.client.types.Alignment)`

    - #### getFacetLabelHoverAlign

          public Alignment getFacetLabelHoverAlign()

      Allows the developer to override the horizontal text alignment of hover tips shown for facetLabels. If unspecified the hover canvas content alignment will be set by `this.hoverAlign` if specified.
      Returns:
        Alignment
      See Also:
        `Canvas.getHoverAlign()`

    - #### setFacetLabelHoverHeight

          public void setFacetLabelHoverHeight(java.lang.Integer facetLabelHoverHeight)

      If specified and `this.showHover` is true, this is the default height to apply to hover tips shown for facetLabels. If unset, the hover canvas will be sized to `this.hoverHeight` if specified instead.

      Note : This is an advanced setting

      Parameters:
        `facetLabelHoverHeight` - Default value is null
      See Also:
        `Canvas.setHoverHeight(java.lang.Integer)`

    - #### getFacetLabelHoverHeight

          public java.lang.Integer getFacetLabelHoverHeight()

      If specified and `this.showHover` is true, this is the default height to apply to hover tips shown for facetLabels. If unset, the hover canvas will be sized to `this.hoverHeight` if specified instead.
      Returns:
        Integer
      See Also:
        `Canvas.getHoverHeight()`

    - #### setFacetLabelHoverStyle

          public void setFacetLabelHoverStyle(java.lang.String facetLabelHoverStyle)

      Allows the developer to override the css class applied to hover tips shown for facet labels. If unspecified, and `this.hoverStyle` is not null, that css class will be applied to facet label hovers instead.

      Note : This is an advanced setting

      Parameters:
        `facetLabelHoverStyle` - See `CSSStyleName` . Default value is null
      See Also:
        `Canvas.setHoverStyle(java.lang.String)`

    - #### getFacetLabelHoverStyle

          public java.lang.String getFacetLabelHoverStyle()

      Allows the developer to override the css class applied to hover tips shown for facet labels. If unspecified, and `this.hoverStyle` is not null, that css class will be applied to facet label hovers instead.
      Returns:
        See `CSSStyleName`
      See Also:
        `Canvas.getHoverStyle()`

    - #### setFacetLabelHoverVAlign

          public void setFacetLabelHoverVAlign(VerticalAlignment facetLabelHoverVAlign)

      Allows the developer to override the vertical text alignment of hover tips shown for facetLabels. If unspecified the hover canvas content alignment will be set by `this.hoverVAlign` if specified.

      Note : This is an advanced setting

      Parameters:
        `facetLabelHoverVAlign` - Default value is null
      See Also:
        `Canvas.setHoverVAlign(com.smartgwt.client.types.VerticalAlignment)`

    - #### getFacetLabelHoverVAlign

          public VerticalAlignment getFacetLabelHoverVAlign()

      Allows the developer to override the vertical text alignment of hover tips shown for facetLabels. If unspecified the hover canvas content alignment will be set by `this.hoverVAlign` if specified.
      Returns:
        VerticalAlignment
      See Also:
        `Canvas.getHoverVAlign()`

    - #### setFacetLabelHoverWidth

          public void setFacetLabelHoverWidth(java.lang.Integer facetLabelHoverWidth)

      If specified and `this.showHover` is true, this is the default width to apply to hover tips shown for facetLabels. If unset, the hover canvas will be sized to `this.hoverWidth` if specified instead.

      Note : This is an advanced setting

      Parameters:
        `facetLabelHoverWidth` - Default value is null
      See Also:
        `Canvas.setHoverWidth(java.lang.Integer)`

    - #### getFacetLabelHoverWidth

          public java.lang.Integer getFacetLabelHoverWidth()

      If specified and `this.showHover` is true, this is the default width to apply to hover tips shown for facetLabels. If unset, the hover canvas will be sized to `this.hoverWidth` if specified instead.
      Returns:
        Integer
      See Also:
        `Canvas.getHoverWidth()`

    - #### setFacets

          public void setFacets(Facet... facets)
                         throws java.lang.IllegalStateException

      Facet definitions for this CubeGrid. Facets, also called "dimensions", are orthogonal aspects of the data model.

      For example, you can look at profit by the facets "plant and product" or by "product and plant" and it's the same number, because the facets - plant and product - are the same. What would change the profit numbers would be to remove a facet, called "summarizing", or add a new facet, called "drilling down". For example, showing profit by plant and product, you could "drill down" by adding the region facet, which would divide profit among each region. Or you could remove the "plant" facet, showing total profit for each "product", summed across all plants.

      This property need not be set and will automatically be constructed during widget initialization if data is provided up front and `rowFacets` and `columnFacets` have been set. If `facets` is not set and there is no initial data but a DataSource is present, drawing the grid will automatically issue a fetch to allow `facets` to be resolved.

      Parameters:
        `facets` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `getFacet(java.lang.String)`, `Facet`, `getFacetValue(java.lang.String, java.lang.String)`, `FacetValue`

    - #### setFacetTitleAlign

          public void setFacetTitleAlign(Alignment facetTitleAlign)

      Default alignment for facet labels.
      If this method is called after the component has been drawn/initialized: Set the align of a facet title (appears in facet label).
      Parameters:
        `facetTitleAlign` - facet to update. Default value is "center"

    - #### getFacetTitleAlign

          public Alignment getFacetTitleAlign()

      Default alignment for facet labels.
      Returns:
        Alignment

    - #### setFacetValueAlign

          public void setFacetValueAlign(Alignment facetValueAlign)

      Default alignment for facet values (in headers).
      Parameters:
        `facetValueAlign` - Default value is "center"

    - #### getFacetValueAlign

          public Alignment getFacetValueAlign()

      Default alignment for facet values (in headers).
      Returns:
        Alignment

    - #### setFacetValueHoverAlign

          public void setFacetValueHoverAlign(Alignment facetValueHoverAlign)

      Allows the developer to override the horizontal text alignment of hover tips shown for facet values. If unspecified the hover canvas content alignment will be set by `this.hoverAlign` if specified.

      Note : This is an advanced setting

      Parameters:
        `facetValueHoverAlign` - Default value is null
      See Also:
        `Canvas.setHoverAlign(com.smartgwt.client.types.Alignment)`

    - #### getFacetValueHoverAlign

          public Alignment getFacetValueHoverAlign()

      Allows the developer to override the horizontal text alignment of hover tips shown for facet values. If unspecified the hover canvas content alignment will be set by `this.hoverAlign` if specified.
      Returns:
        Alignment
      See Also:
        `Canvas.getHoverAlign()`

    - #### setFacetValueHoverHeight

          public void setFacetValueHoverHeight(java.lang.Integer facetValueHoverHeight)

      If specified and `this.showHover` is true, this is the default height to apply to hover tips shown for facetValues. If unset, the hover canvas will be sized to `this.hoverHeight` if specified instead.

      Note : This is an advanced setting

      Parameters:
        `facetValueHoverHeight` - Default value is null
      See Also:
        `Canvas.setHoverHeight(java.lang.Integer)`

    - #### getFacetValueHoverHeight

          public java.lang.Integer getFacetValueHoverHeight()

      If specified and `this.showHover` is true, this is the default height to apply to hover tips shown for facetValues. If unset, the hover canvas will be sized to `this.hoverHeight` if specified instead.
      Returns:
        Integer
      See Also:
        `Canvas.getHoverHeight()`

    - #### setFacetValueHoverStyle

          public void setFacetValueHoverStyle(java.lang.String facetValueHoverStyle)

      Allows the developer to override the css class applied to hover tips shown for facet values. If unspecified, and `this.hoverStyle` is not null, that css class will be applied to facet value hovers instead.

      Note : This is an advanced setting

      Parameters:
        `facetValueHoverStyle` - See `CSSStyleName` . Default value is null
      See Also:
        `Canvas.setHoverStyle(java.lang.String)`

    - #### getFacetValueHoverStyle

          public java.lang.String getFacetValueHoverStyle()

      Allows the developer to override the css class applied to hover tips shown for facet values. If unspecified, and `this.hoverStyle` is not null, that css class will be applied to facet value hovers instead.
      Returns:
        See `CSSStyleName`
      See Also:
        `Canvas.getHoverStyle()`

    - #### setFacetValueHoverVAlign

          public void setFacetValueHoverVAlign(VerticalAlignment facetValueHoverVAlign)

      Allows the developer to override the vertical text alignment of hover tips shown for facet values. If unspecified the hover canvas content alignment will be set by `this.hoverVAlign` if specified.

      Note : This is an advanced setting

      Parameters:
        `facetValueHoverVAlign` - Default value is null
      See Also:
        `Canvas.setHoverVAlign(com.smartgwt.client.types.VerticalAlignment)`

    - #### getFacetValueHoverVAlign

          public VerticalAlignment getFacetValueHoverVAlign()

      Allows the developer to override the vertical text alignment of hover tips shown for facet values. If unspecified the hover canvas content alignment will be set by `this.hoverVAlign` if specified.
      Returns:
        VerticalAlignment
      See Also:
        `Canvas.getHoverVAlign()`

    - #### setFacetValueHoverWidth

          public void setFacetValueHoverWidth(java.lang.Integer facetValueHoverWidth)

      If specified and `this.showHover` is true, this is the default width to apply to hover tips shown for facetValues. If unset, the hover canvas will be sized to `this.hoverWidth` if specified instead.

      Note : This is an advanced setting

      Parameters:
        `facetValueHoverWidth` - Default value is null
      See Also:
        `Canvas.setHoverWidth(java.lang.Integer)`

    - #### getFacetValueHoverWidth

          public java.lang.Integer getFacetValueHoverWidth()

      If specified and `this.showHover` is true, this is the default width to apply to hover tips shown for facetValues. If unset, the hover canvas will be sized to `this.hoverWidth` if specified instead.
      Returns:
        Integer
      See Also:
        `Canvas.getHoverWidth()`

    - #### setFixedFacetValues

          public void setFixedFacetValues(FacetValueMap fixedFacetValues)
                                   throws java.lang.IllegalStateException

      A `FacetValueMap` describing the set of facet values that should be regarded as "fixed" in this cubeGrid. These are used as fixed criteria for load on demand, and also allow using a dataset with more facets in it than are currently shown in the grid.
      Parameters:
        `fixedFacetValues` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `addFacet(java.lang.String)`, `removeFacet(java.lang.String)`

    - #### getFixedFacetValues

          public FacetValueMap getFixedFacetValues()

      A `FacetValueMap` describing the set of facet values that should be regarded as "fixed" in this cubeGrid. These are used as fixed criteria for load on demand, and also allow using a dataset with more facets in it than are currently shown in the grid.
      Returns:
        FacetValueMap
      See Also:
        `addFacet(java.lang.String)`, `removeFacet(java.lang.String)`

    - #### setHideEmptyAxis

          public void setHideEmptyAxis(Axis hideEmptyAxis)
                                throws java.lang.IllegalStateException

      With `hideEmptyFacetValues`, controls on which axis hiding of empty values is applied, "row" (only empty rows are hidden), "column" (only empty columns are hidden) or both (the default).
      Parameters:
        `hideEmptyAxis` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getHideEmptyAxis

          public Axis getHideEmptyAxis()

      With `hideEmptyFacetValues`, controls on which axis hiding of empty values is applied, "row" (only empty rows are hidden), "column" (only empty columns are hidden) or both (the default).
      Returns:
        Axis

    - #### setHideEmptyFacetValues

          public void setHideEmptyFacetValues(java.lang.Boolean hideEmptyFacetValues)
                                       throws java.lang.IllegalStateException

      This causes the headers for any combination of facetValues for which there are no cellRecords to be suppressed.

      To use this feature, either:

      - all must be provided via `setData()` before the CubeGrid is first drawn, OR
      - all data must be returned by the first DataSource fetch, OR
      - `hideEmptyAxis` must be set to either "row" or "column" so that empty values are only automatically hidden for one axis
      This last point is required because there is no way to determine whether a row is empty unless data for all columns of the row has been loaded (and vice-versa). For this reason if you set hideEmptyFacetValues but do not set hideEmptyAxis, the default behavior of `loading only visible data` is automatically disabled and only `fixedFacetValues` will be sent as criteria.
      Parameters:
        `hideEmptyFacetValues` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getHideEmptyFacetValues

          public java.lang.Boolean getHideEmptyFacetValues()

      This causes the headers for any combination of facetValues for which there are no cellRecords to be suppressed.

      To use this feature, either:

      - all must be provided via `setData()` before the CubeGrid is first drawn, OR
      - all data must be returned by the first DataSource fetch, OR
      - `hideEmptyAxis` must be set to either "row" or "column" so that empty values are only automatically hidden for one axis
      This last point is required because there is no way to determine whether a row is empty unless data for all columns of the row has been loaded (and vice-versa). For this reason if you set hideEmptyFacetValues but do not set hideEmptyAxis, the default behavior of `loading only visible data` is automatically disabled and only `fixedFacetValues` will be sent as criteria.
      Returns:
        Boolean

    - #### setHilites

          public void setHilites(Hilite... hilites)

      Hilites to be applied to the data for this component. See `Hiliting`.
      Specified by:
        `setHilites` in interface `DataBoundComponent`
      Overrides:
        `setHilites` in class `ListGrid`
      Parameters:
        `hilites` - Default value is null
      See Also:
        `Hiliting overview and related methods`

    - #### getHilites

          public Hilite[] getHilites()

      Hilites to be applied to the data for this component. See `Hiliting`.
      Specified by:
        `getHilites` in interface `DataBoundComponent`
      Overrides:
        `getHilites` in class `ListGrid`
      Returns:
        Hilite...
      See Also:
        `Hiliting overview and related methods`

    - #### setInnerHeaderBaseStyle

          public void setInnerHeaderBaseStyle(java.lang.String innerHeaderBaseStyle)
                                       throws java.lang.IllegalStateException

      `baseStyle` for the buttons in the innermost column header for this cubeGrid.
      Parameters:
        `innerHeaderBaseStyle` - See `CSSStyleName` . Default value is innerHeader
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getInnerHeaderBaseStyle

          public java.lang.String getInnerHeaderBaseStyle()

      `baseStyle` for the buttons in the innermost column header for this cubeGrid.
      Returns:
        See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setMetricFacetId

          public void setMetricFacetId(java.lang.String metricFacetId)
                                throws java.lang.IllegalStateException

      In a CubeGrid that displays values of different types (eg "Revenue" and "Income"), the different types of values on display are enumerated as the facet values of the "metric facet".

      The metric facet is treated identically to any other facet by the CubeGrid: it can be represented as row or column headers, can be innermost or have other facets under it, can be moved around, etc. However when a metric facet is used, `metricFacetId` must be set to allow the CubeGrid to generate meaningful descriptions of values shown in cells for use in hovers and other situations; see `valueTitle` for a full explanation.

      Parameters:
        `metricFacetId` - Default value is "metric"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getMetricFacetId

          public java.lang.String getMetricFacetId()

      In a CubeGrid that displays values of different types (eg "Revenue" and "Income"), the different types of values on display are enumerated as the facet values of the "metric facet".

      The metric facet is treated identically to any other facet by the CubeGrid: it can be represented as row or column headers, can be innermost or have other facets under it, can be moved around, etc. However when a metric facet is used, `metricFacetId` must be set to allow the CubeGrid to generate meaningful descriptions of values shown in cells for use in hovers and other situations; see `valueTitle` for a full explanation.

      Returns:
        String

    - #### setPadTitles

          public void setPadTitles(java.lang.Boolean padTitles)

      Whether to pad titles so they aren't flush with header borders.
      Parameters:
        `padTitles` - Default value is true

    - #### getPadTitles

          public java.lang.Boolean getPadTitles()

      Whether to pad titles so they aren't flush with header borders.
      Returns:
        Boolean

    - #### setRollupValue

          public void setRollupValue(java.lang.String rollupValue)
                              throws java.lang.IllegalStateException

      facetValueId of the default rollupValue for each facet. Can be overridden per facet via facet.rollupValue.
      Parameters:
        `rollupValue` - Default value is "sum"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRollupValue

          public java.lang.String getRollupValue()

      facetValueId of the default rollupValue for each facet. Can be overridden per facet via facet.rollupValue.
      Returns:
        Get the facetValue definition for the facetValue to show when this facet is "rolled up" under another facet, during a breakout.
        A facet is not required to have a rollup value, and if it does not have one, then rollups will simply be blank rows. The facetValueId of the rollup value can be declared as cubeGrid.rollupValue or facet.rollupValue.

    - #### setRowFacets

          public void setRowFacets(java.lang.String... rowFacets)
                            throws java.lang.IllegalStateException

      The list of `ids` for facets that will appear to the left of the body.
      Parameters:
        `rowFacets` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRowFacets

          public java.lang.String[] getRowFacets()

      The list of `ids` for facets that will appear to the left of the body.
      Returns:
        String...

    - #### setRowHeaderBaseStyle

          public void setRowHeaderBaseStyle(java.lang.String rowHeaderBaseStyle)
                                     throws java.lang.IllegalStateException

      `baseStyle` for the buttons in this grid's row headers.
      Parameters:
        `rowHeaderBaseStyle` - See `CSSStyleName` . Default value is rowHeader
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getRowHeaderBaseStyle

          public java.lang.String getRowHeaderBaseStyle()

      `baseStyle` for the buttons in this grid's row headers.
      Returns:
        See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setRowHeaderGridMode

          public void setRowHeaderGridMode(java.lang.Boolean rowHeaderGridMode)
                                    throws java.lang.IllegalStateException

      If enabled row headers for this cubeGrid will be rendered using a `GridRenderer` component. This improves performance for very large cubeGrids.

      Note : This is an advanced setting

      Parameters:
        `rowHeaderGridMode` - Default value is false
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getRowHeaderGridMode

          public java.lang.Boolean getRowHeaderGridMode()

      If enabled row headers for this cubeGrid will be rendered using a `GridRenderer` component. This improves performance for very large cubeGrids.
      Returns:
        Boolean

    - #### getSaveByCell

          public java.lang.Boolean getSaveByCell()
                                          throws java.lang.IllegalStateException

      CubeGrids only support editing by cell.

      Note : This method should be called only after the widget has been rendered.

      Overrides:
        `getSaveByCell` in class `ListGrid`
      Returns:
        Boolean
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.
      See Also:
        `ListGrid.getEditByCell()`, `Editing overview and related methods`

    - #### setShowFacetValueContextMenus

          public void setShowFacetValueContextMenus(boolean showFacetValueContextMenus)

      If true, show facet value context menus with some built-in operations. Otherwise, use generic context menu handling. Use this in place of `ListGrid.showHeaderContextMenu` and `ListGrid.showHeaderMenuButton` for CubeGrids.
      Parameters:
        `showFacetValueContextMenus` - Default value is true

    - #### getShowFacetValueContextMenus

          public boolean getShowFacetValueContextMenus()

      If true, show facet value context menus with some built-in operations. Otherwise, use generic context menu handling. Use this in place of `ListGrid.showHeaderContextMenu` and `ListGrid.showHeaderMenuButton` for CubeGrids.
      Returns:
        boolean

    - #### setSimpleDeselect

          public void setSimpleDeselect(java.lang.Boolean simpleDeselect)

      If true, clicking on the existing selection causes it to be entirely deselected.
      Parameters:
        `simpleDeselect` - Default value is false

    - #### getSimpleDeselect

          public java.lang.Boolean getSimpleDeselect()

      If true, clicking on the existing selection causes it to be entirely deselected.
      Returns:
        Boolean

    - #### setSkinImgDir

          public void setSkinImgDir(java.lang.String skinImgDir)
                             throws java.lang.IllegalStateException

      Default directory for skin images (those defined by the class), relative to the Page-wide `skinDir`.
      Overrides:
        `setSkinImgDir` in class `ListGrid`
      Parameters:
        `skinImgDir` - See `SCImgURL` . Default value is "images/CubeGrid/"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Images overview and related methods`

    - #### getSkinImgDir

          public java.lang.String getSkinImgDir()

      Default directory for skin images (those defined by the class), relative to the Page-wide `skinDir`.
      Overrides:
        `getSkinImgDir` in class `ListGrid`
      Returns:
        See `SCImgURL`
      See Also:
        `Images overview and related methods`

    - #### setSortDirection

          public void setSortDirection(SortDirection sortDirection)

      Direction of sorting if sortedFacet or sortedFacetValues is specified.
      Overrides:
        `setSortDirection` in class `ListGrid`
      Parameters:
        `sortDirection` - Default value is "ascending"
      See Also:
        `SortDirection`, Sort Example

    - #### getSortDirection

          public SortDirection getSortDirection()

      Direction of sorting if sortedFacet or sortedFacetValues is specified.
      Overrides:
        `getSortDirection` in class `ListGrid`
      Returns:
        SortDirection
      See Also:
        `SortDirection`, Sort Example

    - #### setSortedFacetValues

          public void setSortedFacetValues(FacetValueMap sortedFacetValues)

      `FacetValueMap` of facet values representing a set of facetValues by which the cubeGrid data is sorted.
      Parameters:
        `sortedFacetValues` - Default value is null

    - #### getSortedFacetValues

          public FacetValueMap getSortedFacetValues()

      `FacetValueMap` of facet values representing a set of facetValues by which the cubeGrid data is sorted.
      Returns:
        FacetValueMap

    - #### setStyleName

          public void setStyleName(java.lang.String styleName)

      CSS class for the CubeGrid as a whole
      Overrides:
        `setStyleName` in class `ListGrid`
      Parameters:
        `styleName` - See `CSSStyleName` . Default value is "normal"
      See Also:
        `Appearance overview and related methods`

    - #### getStyleName

          public java.lang.String getStyleName()

      CSS class for the CubeGrid as a whole
      Overrides:
        `getStyleName` in class `ListGrid`
      Returns:
        See `CSSStyleName`
      See Also:
        `Appearance overview and related methods`

    - #### setValueExportFormat

          public void setValueExportFormat(java.lang.String valueExportFormat)
                                    throws java.lang.IllegalStateException

      `FormatString` used during exports for numeric or date formatting. See `DataSourceField.exportFormat`.
      Parameters:
        `valueExportFormat` - See `FormatString` . Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `ExportFormatting overview and related methods`

    - #### getValueExportFormat

          public java.lang.String getValueExportFormat()

      `FormatString` used during exports for numeric or date formatting. See `DataSourceField.exportFormat`.
      Returns:
        See `FormatString`
      See Also:
        `ExportFormatting overview and related methods`

    - #### setValueFormat

          public void setValueFormat(java.lang.String valueFormat)
                              throws java.lang.IllegalStateException

      `FormatString` for numeric or date formatting. See `DataSourceField.format`.
      Parameters:
        `valueFormat` - See `FormatString` . Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `ExportFormatting overview and related methods`

    - #### getValueFormat

          public java.lang.String getValueFormat()

      `FormatString` for numeric or date formatting. See `DataSourceField.format`.
      Returns:
        See `FormatString`
      See Also:
        `ExportFormatting overview and related methods`

    - #### setValueProperty

          public void setValueProperty(java.lang.String valueProperty)
                                throws java.lang.IllegalStateException

      Name of the property in a cell record that holds the cell value.
      Parameters:
        `valueProperty` - Default value is "_value"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueProperty

          public java.lang.String getValueProperty()

      Name of the property in a cell record that holds the cell value.
      Returns:
        String

    - #### setValueTitle

          public void setValueTitle(java.lang.String valueTitle)
                             throws java.lang.IllegalStateException

      A label for the data values shown in cells, such as "Sales in Thousands", typically used when the CubeGrid must generate a description for a cell value or set of cell values.

      For example, in a CubeGrid showing "Revenue" by region and product, a cell with a CellRecord like:

            {product:"chairs", region:"northwest", _value:"$5k"}

      Should be described as "Revenue for Chairs for Northwest Region", not "Chairs for Revenue for Northwest Region".

      For CubeGrids that show multiple types of values at once (eg both "Revenue" and "Income") see `metricFacetId`.

      Parameters:
        `valueTitle` - Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getValueTitle

          public java.lang.String getValueTitle()

      A label for the data values shown in cells, such as "Sales in Thousands", typically used when the CubeGrid must generate a description for a cell value or set of cell values.

      For example, in a CubeGrid showing "Revenue" by region and product, a cell with a CellRecord like:

            {product:"chairs", region:"northwest", _value:"$5k"}

      Should be described as "Revenue for Chairs for Northwest Region", not "Chairs for Revenue for Northwest Region".

      For CubeGrids that show multiple types of values at once (eg both "Revenue" and "Income") see `metricFacetId`.

      Returns:
        String

    - #### setWrapFacetTitles

          public void setWrapFacetTitles(java.lang.Boolean wrapFacetTitles)

      Whether to allow text wrapping on facet titles.
      Parameters:
        `wrapFacetTitles` - Default value is false

    - #### getWrapFacetTitles

          public java.lang.Boolean getWrapFacetTitles()

      Whether to allow text wrapping on facet titles.
      Returns:
        Boolean

    - #### setWrapFacetValueTitles

          public void setWrapFacetValueTitles(java.lang.Boolean wrapFacetValueTitles)

      Whether to allow text wrapping on facet value titles.
      Parameters:
        `wrapFacetValueTitles` - Default value is false

    - #### getWrapFacetValueTitles

          public java.lang.Boolean getWrapFacetValueTitles()

      Whether to allow text wrapping on facet value titles.
      Returns:
        Boolean

    - #### addColumnFacet

          public void addColumnFacet(java.lang.String facetId)

      Add a column facet to the view at index "index". Handles the facet already being in the view (does a pivot).
      The facet being added should currently have a fixed facet value (unless it's already part of the view), which will be removed from cubeGrid.fixedFacetValues.
      methodType action
      Parameters:
        `facetId` - facetId to add. Definition must have been provided at init time.
      See Also:
        `removeFacet(java.lang.String)`, `getFixedFacetValues()`

    - #### addColumnFacet

          public void addColumnFacet(java.lang.String facetId,
                                     java.lang.Integer index)

      Add a column facet to the view at index "index". Handles the facet already being in the view (does a pivot).
      The facet being added should currently have a fixed facet value (unless it's already part of the view), which will be removed from cubeGrid.fixedFacetValues.
      methodType action
      Parameters:
        `facetId` - facetId to add. Definition must have been provided at init time.
        `index` - index to add the facet at. 0 = outermost (default innermost)
      See Also:
        `removeFacet(java.lang.String)`, `getFixedFacetValues()`

    - #### addFacet

          public void addFacet(java.lang.String facetId)

      Add a facet to the view, into the row or column facets (intoRows true or false), at index "index". Handles the facet already being in the view (does a pivot).

      The facet being added should currently have a fixed facet value (unless it's already part of the view), which will be removed from cubeGrid.fixedFacetValues.

      Parameters:
        `facetId` - facetId to add. Definition must have been provided at init time.
      See Also:
        `removeFacet(java.lang.String)`, `getFixedFacetValues()`

    - #### addFacet

          public void addFacet(java.lang.String facetId,
                               java.lang.Boolean intoRows)

      See Also:
        `addFacet(java.lang.String)`

    - #### addFacet

          public void addFacet(java.lang.String facetId,
                               java.lang.Boolean intoRows,
                               java.lang.Integer index)

      Add a facet to the view, into the row or column facets (intoRows true or false), at index "index". Handles the facet already being in the view (does a pivot).

      The facet being added should currently have a fixed facet value (unless it's already part of the view), which will be removed from cubeGrid.fixedFacetValues.

      Parameters:
        `facetId` - facetId to add. Definition must have been provided at init time.
        `intoRows` - whether to add facet as a row facet
        `index` - index to add the facet at. 0 = outermost (default innermost)
      See Also:
        `removeFacet(java.lang.String)`, `getFixedFacetValues()`

    - #### addRowFacet

          public void addRowFacet(java.lang.String facetId)

      Add a row facet to the view at index "index". Handles the facet already being in the view (does a pivot).
      The facet being added should currently have a fixed facet value (unless it's already part of the view), which will be removed from cubeGrid.fixedFacetValues.
      methodType action
      Parameters:
        `facetId` - facetId to add. Definition must have been provided at init time.
      See Also:
        `removeFacet(java.lang.String)`, `getFixedFacetValues()`

    - #### addRowFacet

          public void addRowFacet(java.lang.String facetId,
                                  java.lang.Integer index)

      Add a row facet to the view at index "index". Handles the facet already being in the view (does a pivot).
      The facet being added should currently have a fixed facet value (unless it's already part of the view), which will be removed from cubeGrid.fixedFacetValues.
      methodType action
      Parameters:
        `facetId` - facetId to add. Definition must have been provided at init time.
        `index` - index to add the facet at. 0 = outermost (default innermost)
      See Also:
        `removeFacet(java.lang.String)`, `getFixedFacetValues()`

    - #### anyCellSelected

          public java.lang.Boolean anyCellSelected()

      Determine whether any cells are selected in this cubeGrid.
      methodType tester
      Returns:
        true if any cells are selected
      See Also:
        `Selection overview and related methods`

    - #### cellIsSelected

          public java.lang.Boolean cellIsSelected(CellRecord cell)

      Determine whether the cell passed in is selected in this cubeGrid.
      methodType tester
      Parameters:
        `cell` - cell to test
      Returns:
        true if any cells are selected
      See Also:
        `Selection overview and related methods`

    - #### closeFacet

          public void closeFacet(java.lang.String facetId)

      Handler fired when facet is closed
      methodType handler
      Parameters:
        `facetId` - ID of facet that was closed

    - #### collapseField

          public java.lang.Boolean collapseField(FacetValueMap facetValueMap)

      Collapses the specified field. No-ops if it's not showing, or it it's already collapsed.
      Parameters:
        `facetValueMap` - field specified as a facetValueMap
      Returns:
        whether specified field was actually collapsed

    - #### dataArrived

          public void dataArrived()

      Notification method fired when new data arrives from the server to be displayed in this CubeGrid. For example in response to the user openng a collapsed facet, or as a result of an initial fetch request for all data from a CubeGrid where `facets` is not set and there is no initial data. Only applies to databound CubeGrids.

    - #### deselectAll

          public void deselectAll()

      Deselect all cells and facetValues.
      methodType action
      See Also:
        `Selection overview and related methods`

    - #### deselectAllCells

          public void deselectAllCells()

      Deselect all cells.
      See Also:
        `Selection overview and related methods`

    - #### deselectAllFacetValues

          public void deselectAllFacetValues()

      Deselect all headers in a headerBar (specified by facetId) or all headerBars (if no facetId).
      methodType action
      See Also:
        `Selection overview and related methods`

    - #### deselectAllFacetValues

          public void deselectAllFacetValues(java.lang.String facetId)

      Deselect all headers in a headerBar (specified by facetId) or all headerBars (if no facetId).
      methodType action
      Parameters:
        `facetId` - ID of facet - if null, selects all headerbars' headers
      See Also:
        `Selection overview and related methods`

    - #### deselectCells

          public void deselectCells(CellRecord[] cellList)

      Deselect cells that match a `FacetValueMap`. Also supports an explicit list of CellRecords or cell IDs.
      Parameters:
        `cellList` - cells to deselect
      See Also:
        `Selection overview and related methods`

    - #### deselectCells

          public void deselectCells(FacetValueMap cellList)

      Deselect cells that match a `FacetValueMap`. Also supports an explicit list of CellRecords or cell IDs.
      Parameters:
        `cellList` - cells to deselect
      See Also:
        `Selection overview and related methods`

    - #### deselectCells

          public void deselectCells(java.lang.String... cellList)

      Deselect cells that match a `FacetValueMap`. Also supports an explicit list of CellRecords or cell IDs.
      Parameters:
        `cellList` - cells to deselect
      See Also:
        `Selection overview and related methods`

    - #### deselectFacetValue

          public void deselectFacetValue(java.lang.String facetId,
                                         java.lang.String facetValueId)

      Deselect the header for a given facet value.
      methodType action
      Parameters:
        `facetId` - ID of facet
        `facetValueId` - ID of facetValue to select
      See Also:
        `Selection overview and related methods`

    - #### expandField

          public java.lang.Boolean expandField(FacetValueMap facetValueMap)

      Expands the specified field. No-ops if it's not showing, or if it's already expanded.
      Parameters:
        `facetValueMap` - field specified as a facetValueMap
      Returns:
        whether specified field was actually expanded

    - #### exportClientData

          public void exportClientData(java.util.Map settings)

      Exports this component's data with client-side formatters applied, so is suitable for direct display to users. This feature requires the Smart GWT server.

      The export format will combine the column facet value titles, generating a single row of column headers at the top with titles such as "All Years - Budget" if Time and Scenario were column facets. The row facet value titles for separate facets won't be combined, so that each row facet will have a separate column, with the facet titles at the top in the "column header" row, and the row facet value titles below their corresponding facet title. Data values each get their own row and column position.

      Parameters:
        `settings` - contains configuration settings for the export, including:
        - facetSeparatorString (String) - if specified, the separator to use in favor of `exportFacetSeparatorString` when combining titles from multiple facet values.
      See Also:
        `ListGrid.exportClientData()`

    - #### exportClientData

          public void exportClientData(java.util.Map settings,
                                       DSRequest requestProperties)

      See Also:
        `exportClientData(java.util.Map)`

    - #### exportClientData

          public void exportClientData(java.util.Map settings,
                                       DSRequest requestProperties,
                                       RPCCallback callback)

      Exports this component's data with client-side formatters applied, so is suitable for direct display to users. This feature requires the Smart GWT server.

      The export format will combine the column facet value titles, generating a single row of column headers at the top with titles such as "All Years - Budget" if Time and Scenario were column facets. The row facet value titles for separate facets won't be combined, so that each row facet will have a separate column, with the facet titles at the top in the "column header" row, and the row facet value titles below their corresponding facet title. Data values each get their own row and column position.

      Parameters:
        `settings` - contains configuration settings for the export, including:
        - facetSeparatorString (String) - if specified, the separator to use in favor of `exportFacetSeparatorString` when combining titles from multiple facet values.
        `requestProperties` - Request properties for the export.
        `callback` - Optional callback. If you specify `exportToClient`: false in the request properties, this callback will fire after export completes. Otherwise the callback will fire right before the download request is made to the server.
      See Also:
        `ListGrid.exportClientData()`

    - #### addFacetAddedHandler

          public com.google.gwt.event.shared.HandlerRegistration addFacetAddedHandler(FacetAddedHandler handler)

      Add a facetAdded handler.

      Notification fired when a new facet is added.

      Specified by:
        `addFacetAddedHandler` in interface `HasFacetAddedHandlers`
      Parameters:
        `handler` - the facetAdded handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### facetHasSelection

          public java.lang.Boolean facetHasSelection(java.lang.String facetId)

      Return whether any facet value for this facet is selected in headers. If no facetId passed, return whether any facet has a selection.
      methodType tester
      Parameters:
        `facetId` - Id for facet to test
      Returns:
        true if any facet value in this header is selected
      See Also:
        `Selection overview and related methods`

    - #### addFacetMovedHandler

          public com.google.gwt.event.shared.HandlerRegistration addFacetMovedHandler(FacetMovedHandler handler)

      Add a facetMoved handler.

      Notification fired when a facet is moved.

      Specified by:
        `addFacetMovedHandler` in interface `HasFacetMovedHandlers`
      Parameters:
        `handler` - the facetMoved handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### addFacetRemovedHandler

          public com.google.gwt.event.shared.HandlerRegistration addFacetRemovedHandler(FacetRemovedHandler handler)

      Add a facetRemoved handler.

      Notification fired when a facet is removed.

      Specified by:
        `addFacetRemovedHandler` in interface `HasFacetRemovedHandlers`
      Parameters:
        `handler` - the facetRemoved handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### addFacetValueSelectionChangedHandler

          public com.google.gwt.event.shared.HandlerRegistration addFacetValueSelectionChangedHandler(FacetValueSelectionChangedHandler handler)

      Add a facetValueSelectionChanged handler.

      Handler/Notification function for facetValue selection change (no default implementation).

      Specified by:
        `addFacetValueSelectionChangedHandler` in interface `HasFacetValueSelectionChangedHandlers`
      Parameters:
        `handler` - the facetValueSelectionChanged handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### addFixedFacetValueChangedHandler

          public com.google.gwt.event.shared.HandlerRegistration addFixedFacetValueChangedHandler(FixedFacetValueChangedHandler handler)

      Add a fixedFacetValueChanged handler.

      Notification fired when a fixed facet value is set for some facet.

      Specified by:
        `addFixedFacetValueChangedHandler` in interface `HasFixedFacetValueChangedHandlers`
      Parameters:
        `handler` - the fixedFacetValueChanged handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### getCellColumn

          public int getCellColumn(CellRecord cellRecord)

      Given a record in this grid, this method returns the colNum in which the record is displayed.
      Parameters:
        `cellRecord` - record to find coordinates for
      Returns:
        Column number for the record. Returns -1 if the record is not found.

    - #### getCellFacetValues

          public FacetValueMap getCellFacetValues(int rowNum,
                                                  int colNum)

      Given a cell coordinate within this CubeGrid return a `FacetValueMap` indicating the facet values for the cell.
      Parameters:
        `rowNum` - row index of the cell
        `colNum` - column index of the cell
      Returns:
        facet values for the specified cell. Returns null if the specified cell is not present in the grid.

    - #### getCellRecord

          public ListGridRecord getCellRecord(int rowNum,
                                              int colNum)

      Return the pointer to a particular record by record and column number.
      Parameters:
        `rowNum` - row index of record to return.
        `colNum` - column index of record to return.
      Returns:
        Record object for the row.
      See Also:
        `ListGrid.getRecord(int)`, `ListGrid.getEditedRecord(int)`

    - #### getCellRow

          public int getCellRow(CellRecord cellRecord)

      Given a record in this grid, this method returns the rowNum on which the record is displayed.
      Parameters:
        `cellRecord` - record to find coordinates for
      Returns:
        Row number for the record. Returns -1 if the record is not found.

    - #### getColumnFacetValues

          public FacetValueMap getColumnFacetValues(int colNum)

      Return a `FacetValueMap` indicating the facet values for a specific column in the grid.
      Parameters:
        `colNum` - index of the column
      Returns:
        facet values for the specified column. Returns null if the specified column is not present in the grid.

    - #### getEditValue

          public java.lang.Object getEditValue(int rowNum,
                                               int colNum)

      Returns the current temporary locally stored edit value for a cell being edited. Note this is the `valueProperty` that will be saved for the cell in question.
      Overrides:
        `getEditValue` in class `ListGrid`
      Parameters:
        `rowNum` - index of the row for which the editValue should be returned
        `colNum` - index of the column for which value should be returned
      Returns:
        edit value for the cell
      See Also:
        `Editing overview and related methods`

    - #### getEventColumn

          public int getEventColumn()

      Returns the column number of the most recent mouse event.
      Overrides:
        `getEventColumn` in class `ListGrid`
      Returns:
        column number, or -2 if beyond last drawn column
      See Also:
        `Selection overview and related methods`

    - #### getEventColumn

          public int getEventColumn(java.lang.Integer x)

      Returns the column number of the most recent mouse event.
      Overrides:
        `getEventColumn` in class `ListGrid`
      Parameters:
        `x` - optional x-coordinate to obtain column number for, in lieu of the x coordinate of the last mouse event
      Returns:
        column number, or -2 if beyond last drawn column
      See Also:
        `Selection overview and related methods`

    - #### getEventRow

          public int getEventRow()

      Returns the row number of the most recent mouse event.
      Overrides:
        `getEventRow` in class `ListGrid`
      Returns:
        row number, or -2 if beyond last drawn row
      See Also:
        `Selection overview and related methods`

    - #### getEventRow

          public int getEventRow(java.lang.Integer y)

      Returns the row number of the most recent mouse event.
      Overrides:
        `getEventRow` in class `ListGrid`
      Parameters:
        `y` - optional y-coordinate to obtain row number, in lieu of the y coordinate of the last mouse event
      Returns:
        row number, or -2 if beyond last drawn row
      See Also:
        `Selection overview and related methods`

    - #### getFacet

          public Facet getFacet(java.lang.String facetId)

      Get a facet definition by facetId. Constant time.
      Parameters:
        `facetId` - the id of the facet to retrieve
      Returns:
        the Facet if found, or null
      See Also:
        `Facet`

    - #### getFacetsHavingSelection

          public java.lang.String[] getFacetsHavingSelection()

      Return the list of facets that have any selection in their headers.
      methodType getter
      Returns:
        list of facets that have any selection in their headers
      See Also:
        `Selection overview and related methods`

    - #### getFacetValue

          public FacetValue getFacetValue(java.lang.String facetId,
                                          java.lang.String facetValueId)

      Get a facet value definition by facetId and facetValueId. Constant time.
      Parameters:
        `facetId` - the id of the facet to retrieve
        `facetValueId` - the id of the facet value to retrieve
      Returns:
        the FacetValue if found, or null
      See Also:
        `FacetValue`

    - #### getFacetValuesColumn

          public int getFacetValuesColumn(FacetValueMap facetValues)

      Get the index of the first column in the grid that matches the specified FacetValueMap.

      The facetValues passed in should contain values for at least one column facet. It may contain properties other than column facets, which will be ignored. If values are sparse (values not specified for every column facet), the first column matching the specified facet values will be returned.

      Parameters:
        `facetValues` - facet values to find
      Returns:
        index of first column in the grid that matches the facet values passed in, or -1 if not found

    - #### getFacetValuesRow

          public int getFacetValuesRow(FacetValueMap facetValues)

      Get the index of the first row in the grid that matches the specified FacetValueMap.

      The facetValues passed in should contain values for at least one row facet. It may contain properties other than row facets, which will be ignored. If values are sparse (values not specified for every row facet), the first row matching the specified facet values will be returned.

      Parameters:
        `facetValues` - facet values to find
      Returns:
        index of first row in the grid that matches the facet values passed in, or -1 if not found

    - #### getRowFacetValues

          public FacetValueMap getRowFacetValues(int rowNum)

      Return a `FacetValueMap` indicating the facet values for a specific row in the grid.
      Parameters:
        `rowNum` - index of the row
      Returns:
        facet values for the specified row. Returns null if the specified row is not present in the grid.

    - #### getSelectedCellIds

          public java.lang.String[] getSelectedCellIds()

      Returns an array of the IDs of all selected cell records.
      methodType getter
      Returns:
        array of the selected cell IDs
      See Also:
        `Selection overview and related methods`

    - #### getSelectedCells

          public CellRecord[] getSelectedCells()

      Returns an array of the selected cell records.
      methodType getter
      Returns:
        array of the selected cell records
      See Also:
        `Selection overview and related methods`

    - #### getSelectedFacetValues

          public FacetValueMap[] getSelectedFacetValues(java.lang.String facetId)

      Returns an array of facetValues objects indicating the headers that are selected in the headerBar for this facet. If facetId is not passed, returns selection for all facets.
      Parameters:
        `facetId` - id for facet for which we are getting selected facetValues
      Returns:
        selected facetValues
      See Also:
        `Selection overview and related methods`

    - #### hasChanges

          public java.lang.Boolean hasChanges()

      Determines whether any cells in this cubeGrid have been edited but not yet saved to the underlying data set.
      Overrides:
        `hasChanges` in class `ListGrid`
      Returns:
        true if any record in the grid has been edited but not yet saved
      See Also:
        `Editing overview and related methods`

    - #### hiliteFacetValue

          public java.lang.Boolean hiliteFacetValue(java.lang.String facetID,
                                                    java.lang.String facetValueID,
                                                    java.lang.String hiliteID)

      Apply a hilite to all cells corresponding to a facetValue.
      methodType action
      Parameters:
        `facetID` - facet ID
        `facetValueID` - facet value ID
        `hiliteID` - hilite ID
      Returns:
        true if the cells were successfully hilited.
      See Also:
        `Hiliting overview and related methods`

    - #### recordHasChanges

          public java.lang.Boolean recordHasChanges(int rowNum,
                                                    int colNum)

      If this cubeGrid can be edited, this method will return true if the record passed in has been edited, but the edits have not yet been saved to the CubeGrid's data object.
      Parameters:
        `rowNum` - row index of record to check for changes
        `colNum` - column index of the record to check for changes
      Returns:
        true if the record has been edited but not yet saved
      See Also:
        `Editing overview and related methods`

    - #### removeFacet

          public void removeFacet(java.lang.String facetId)

      Remove a facet from the current view, using a fixed value from that facet. For example, remove the "months" facet from the view, collapsing to just January, or total for all months.
      Parameters:
        `facetId` - facetId to remove
      See Also:
        `addFacet(java.lang.String)`, `getFixedFacetValues()`

    - #### removeFacet

          public void removeFacet(java.lang.String facetId,
                                  java.lang.String fixedFacetValueId)

      Remove a facet from the current view, using a fixed value from that facet. For example, remove the "months" facet from the view, collapsing to just January, or total for all months.
      Parameters:
        `facetId` - facetId to remove
        `fixedFacetValueId` - New fixed value for the facet, to be added to cubeGrid.fixedFacetValues. Default is the rollup value for the facet.
      See Also:
        `addFacet(java.lang.String)`, `getFixedFacetValues()`

    - #### resizeFacetValue

          public void resizeFacetValue(java.lang.String facetValueId,
                                       int newWidth)

      Resizes all columns for the provided facetValueId, which must be a facetValueId from the innermost column facet.
      Parameters:
        `facetValueId` - facetValueId of columns to be resized
        `newWidth` - column's new width

    - #### selectAllCells

          public void selectAllCells()

      Select all cells.
      See Also:
        `Selection overview and related methods`

    - #### selectAllFacetValues

          public void selectAllFacetValues()

      Select/deselect all headers in a headerBar (specified by facetId) or all headerBars (if no facetId).
      methodType action
      See Also:
        `Selection overview and related methods`

    - #### selectAllFacetValues

          public void selectAllFacetValues(java.lang.String facetId)

      See Also:
        `selectAllFacetValues()`

    - #### selectAllFacetValues

          public void selectAllFacetValues(java.lang.String facetId,
                                           java.lang.Boolean newState)

      Select/deselect all headers in a headerBar (specified by facetId) or all headerBars (if no facetId).
      methodType action
      Parameters:
        `facetId` - ID of facet - if null, selects all headerbars' headers
        `newState` - new selection state - if null defaults to true
      See Also:
        `Selection overview and related methods`

    - #### selectCells

          public void selectCells(CellRecord[] cellList)

      Select/deselect cells that match a `FacetValueMap`. Also supports an explicit list of CellRecords or cell IDs.
      Parameters:
        `cellList` - cells to select
      See Also:
        `Selection overview and related methods`

    - #### selectCells

          public void selectCells(FacetValueMap cellList)

      Select/deselect cells that match a `FacetValueMap`. Also supports an explicit list of CellRecords or cell IDs.
      Parameters:
        `cellList` - cells to select
      See Also:
        `Selection overview and related methods`

    - #### selectCells

          public void selectCells(java.lang.String... cellList)

      Select/deselect cells that match a `FacetValueMap`. Also supports an explicit list of CellRecords or cell IDs.
      Parameters:
        `cellList` - cells to select
      See Also:
        `Selection overview and related methods`

    - #### selectCells

          public void selectCells(CellRecord[] cellList,
                                  boolean newState)

      Select/deselect cells that match a `FacetValueMap`. Also supports an explicit list of CellRecords or cell IDs.
      Parameters:
        `cellList` - cells to select
        `newState` - new selection state (if null, defaults to true)
      See Also:
        `Selection overview and related methods`

    - #### selectFacetValue

          public void selectFacetValue(java.lang.String facetId,
                                       java.lang.String facetValueId)

      Select/deselect the header for a given facet value.
      methodType action
      Parameters:
        `facetId` - ID of facet
        `facetValueId` - ID of facetValue to select
      See Also:
        `Selection overview and related methods`

    - #### selectFacetValue

          public void selectFacetValue(java.lang.String facetId,
                                       java.lang.String facetValueId,
                                       java.lang.Boolean newState)

      Select/deselect the header for a given facet value.
      methodType action
      Parameters:
        `facetId` - ID of facet
        `facetValueId` - ID of facetValue to select
        `newState` - new selection state - if null defaults to true
      See Also:
        `Selection overview and related methods`

    - #### setEditValue

          public void setEditValue(int rowNum,
                                   int colNum,
                                   java.lang.Object value)

      Set the edit value for some cell in the cube grid.

      Note that cubeGrids display one record per cell - the value passed in should be the desired edit value for the `valueProperty` of the record.

      Overrides:
        `setEditValue` in class `ListGrid`
      Parameters:
        `rowNum` - Row number
        `colNum` - Column number
        `value` - New value for the record
      See Also:
        `Editing overview and related methods`

    - #### setFacetTitle

          public void setFacetTitle(java.lang.String facetId,
                                    java.lang.String newTitle)

      Set the title of a facet (appears in facet label).
      Parameters:
        `facetId` - facet to update
        `newTitle` - title for the facet

    - #### setFacetValueTitle

          public void setFacetValueTitle(java.lang.String facetId,
                                         java.lang.String facetValueId,
                                         java.lang.String newTitle)

      Set the title for a facet value.
      Parameters:
        `facetId` - facet to update
        `facetValueId` - facetValue to update
        `newTitle` - title for the facet

    - #### setFacetValueTitleAlign

          public void setFacetValueTitleAlign(java.lang.String facetId,
                                              java.lang.String facetValueId,
                                              Alignment align)

      Set the align for the title for a facet value.
      Parameters:
        `facetId` - facet to update
        `facetValueId` - facetValue to update
        `align` - new alignment for facet value title

    - #### setFixedFacetValue

          public void setFixedFacetValue(java.lang.String facetId,
                                         java.lang.String fixedFacetValueId)

      Modify fixedFacetValues for this cubeGrid.
      Parameters:
        `facetId` - facetId
        `fixedFacetValueId` - fixedFacetValue New fixed value for the facet, to be added to cubeGrid.fixedFacetValues. Default is the rollup value for the facet.

    - #### addSortByFacetIdHandler

          public com.google.gwt.event.shared.HandlerRegistration addSortByFacetIdHandler(SortByFacetIdHandler handler)

      Add a sortByFacetId handler.

      Called when a sort control is clicked on a FacetHeader. Does nothing by default.

      Specified by:
        `addSortByFacetIdHandler` in interface `HasSortByFacetIdHandlers`
      Parameters:
        `handler` - the sortByFacetId handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### addSortByFacetValuesHandler

          public com.google.gwt.event.shared.HandlerRegistration addSortByFacetValuesHandler(SortByFacetValuesHandler handler)

      Add a sortByFacetValues handler.

      Called when a sort control is clicked on a FacetValueHeader. Does nothing by default.

      Specified by:
        `addSortByFacetValuesHandler` in interface `HasSortByFacetValuesHandlers`
      Parameters:
        `handler` - the sortByFacetValues handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### toggleFieldOpenState

          public java.lang.Boolean toggleFieldOpenState(FacetValueMap facetValueMap)

      Toggles the open state of the specified field. No-ops if it's not showing.
      Parameters:
        `facetValueMap` - field specified as a facetValueMap
      Returns:
        whether specified field's open state was toggled

    - #### setDefaultProperties

          public static void setDefaultProperties(CubeGrid cubeGridProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `cubeGridProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### hiliteCell

          public java.lang.Boolean hiliteCell(int rowNum,
                                              int colNum,
                                              java.lang.String hiliteID)

      Apply a hilite to a specific cell. Note: can be called either as hiliteCell(cellObject, hiliteID) or hiliteCell(row, column, hiliteID)
      methodType action
      Parameters:
        `row` - of cell to hilite
        `column` - of cell to hilite
        `hilite` - id
      Returns:
        true if the cell was successfully hilited.
      See Also:
        `Hiliting overview and related methods`

    - #### deselectCell

          public void deselectCell(java.lang.String cell)

      Deselect a single cell - accepts cell ID.
      Parameters:
        `cell` - cell to deselect

    - #### deselectCell

          public void deselectCell(CellRecord cell)

      Deselect a single cell - accepts cellRecord.
      Parameters:
        `cell` - cell to deselect

    - #### selectCell

          public void selectCell(java.lang.String ID)

      Select a single cell - accepts cell ID or cell record.
      methodType action
      Parameters:
        `cell` - cell to select

    - #### selectCell

          public void selectCell(Record cell)

      Select a single cell - accepts cell ID or cell record.
      methodType action
      Parameters:
        `cell` - cell to select

    - #### getCellCoordinates

          public int[] getCellCoordinates(CellRecord cellRecord)

      Given a record in this grid, this method returns the coordinates of the cell in which the record is displayed as a 2 element array.
      Parameters:
        `cellRecord` - record to find coordinates for
      Returns:
        2 element array containing `[rowNum,colNum]` for the cell, or `null` if the record is not found.

    - #### getEditedCell

          public java.lang.Object getEditedCell(int rowNum,
                                                int colNum)

      Returns the current value of a cell. If the cell has an outstanding edit value, this will be returned, otherwise the underlying value of the record will be returned.
      Overrides:
        `getEditedCell` in class `ListGrid`
      Parameters:
        `rowNum` - rowNum of the record being edited
        `colNum` - colNum of the cell
      Returns:
        Current edit value, or underlying value for the cell.
      See Also:
        `Editing overview and related methods`

    - #### getEditedCell

          public java.lang.Object getEditedCell(Record record)

      Returns the current value of a cell. If the cell has an outstanding edit value, this will be returned, otherwise the underlying value of the record will be returned.
      Parameters:
        `record` - rowNum of the record being edited, or an Object containing values for all the record's primary keys
        `colNum` - colNum of the cell. Only required if the first parameter is a rowNum
      Returns:
        Current edit value, or underlying value for the cell.
      See Also:
        `Editing overview and related methods`

    - #### getEditedRecord

          public CellRecord getEditedRecord(int rowNum,
                                            int colNum)

      Returns the combination of unsaved edits (if any) and original values (if any) for a given cell being edited.

      The returned value is never null, and can be freely modified.

      Parameters:
        `rowNum` - of the record being edited
        `colNum` - colNum of the record being edited
      Returns:
        A copy of the record with unsaved edits included
      See Also:
        `Editing overview and related methods`

    - #### getEditedRecord

          public CellRecord getEditedRecord(Record baseRecord)

      Returns the combination of unsaved edits (if any) and original values (if any) for a given cell being edited.

      The returned value is never null, and can be freely modified.

      Parameters:
        `record` - being edited
      Returns:
        A copy of the record with unsaved edits included
      See Also:
        `Editing overview and related methods`

    - #### setEnableCharting

          public void setEnableCharting(java.lang.Boolean enableCharting)

      If set to true, context menu items will be included on the cells and headers providing the user with an option to create a chart of the cubeGrid's data set. See `chartData` for more information.
      Parameters:
        `enableCharting` - enableCharting Default value is false

    - #### getEnableCharting

          public java.lang.Boolean getEnableCharting()

      If set to true, context menu items will be included on the cells and headers providing the user with an option to create a chart of the cubeGrid's data set. See `chartData` for more information.
      Returns:
        Boolean

    - #### analyticsLoaded

          public static boolean analyticsLoaded()

      Static method indicating whether the optional Analytics module is loaded for the page. The CubeGrid component requires this module.
      Returns:
        true if the Analytics module is present

    - #### makeChart

          public FacetChart makeChart(FacetValueMap fixedFacetValues,
                                      java.lang.String[] variableFacets,
                                      FacetChart chartProperties)

      Chart the portion of the dataset indicated by `fixedFacetValues`, for all values of the `variableFacets`.

      One, two or more variableFacets may be passed. Two variable facets for a column chart will result in `stacking` or clustering. Three facets or more may be supported by some `chartTypes` or `charting engines`.

      Parameters:
        `fixedFacetValues` - (FacetValueMap) set of facet values to hold constant. Pass null to chart the entire dataset.
        `variableFacets` - (Array of FacetIds) set of facets to be charted
        `chartProperties` - (FacetChart properties) properties to pass through to the created `FacetChart`
      Returns:
        (FacetChart) created Chart instance

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.cube.CubeGridLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `ListGrid`